      PROGRAM ANALNT
*.
*...MAIN     The main program for analyzing ntuples created by lproto
*.
*. SEQUENCE  : NTUPLE RCREP  UCNTRL XECGEO XECINT
*. CALLS     : FFGO   FFINIT FFKEY  FFSET  FFUSET
*.           : HBNAME HGNT   HGNTF  HLIMIT HNOENT HREND  HRIN   HROPEN
*.           : PRIREP REPORT VBLANK XEGINI
*.           : USINIT USSETR USBAT  USFIN
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.01
*. CREATED   : 08-May-00
*. LAST MOD  : 04-Jul-02
*.
*. Modification Log.
*. 04-Jul-02   K.Ozone         (V1.01) Changed/Added block names in
*.                             ntuple.
*. 08-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's main_nt.F.
*.
*.**********************************************************************
*.
#include "declare.inc"
*
      INTEGER NHMEM,  HMEMOR
      PARAMETER (NHMEM = 2000000)
      COMMON /PAWC/ HMEMOR(NHMEM)
*
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "rcrep.inc"
#include "ucntrl.inc"
*
      INTEGER LUNNT
      PARAMETER (LUNNT = 81)
      INTEGER IERR,   IFILE,  NEVALL
      INTEGER NEVENT
      CHARACTER*80 CPSNAM, CHBNAM
      INTEGER ICYCLE
*
      EXTERNAL FFUSER
*
*-- Initialize HBOOK memory
*
      CALL HLIMIT(NHMEM)
*
*-- Initialize /UCNTRL/
*
      LUNREP = 6
      LUNHBK = 10
      LUNPS  = 11
      CALL VBLANK(LFINAM, NAMLWO)
      CALL VBLANK(LHBNAM, NAMLWO)
      CALL VBLANK(LPSNAM, NAMLWO)
      NTUPON = 0
      NFILES = 0
*
*-- Initialization for geometry
*
      NXPMT  = 6
      NYPMT  = 6
      NZPMT  = 8
      PMTINT = 6.2
*
*-- Initialize FFREAD
*
      CALL FFINIT(15000)
      CALL FFSET('LINP', 5)
      CALL FFSET('LOUT', LUNREP)
      CALL FFSET('SIZE', 12)
      CALL FFUSET(FFUSER)
*
      CALL FFKEY('NPMT',   NXPMT,   3, 'INTEGER')
      CALL FFKEY('PMTINT', PMTINT,  1, 'REAL')
      CALL FFKEY('FILE',   LFINAM, 20, 'MIXED')
      CALL FFKEY('HIST',   LHBNAM, 20, 'MIXED')
      CALL FFKEY('META',   LPSNAM, 20, 'MIXED')
**    CALL FFKEY('NTUPLE', NTUPON,  1, 'INTEGER')
*
*-- User initialization (defining private FFREAD cards, etc.)
*
      CALL USINIT
*
*-- Read and process FFREAD data cards
*
      CALL FFGO
*
*-- Initialize geometrical parameters in /XECGEO/
*
      CALL XEGINI
*
*-- Open an output HBOOK file
*
      CALL UHTOC(LHBNAM, 4, CHBNAM, NAMLEN)
      IF (CHBNAM .NE. ' ') THEN
         CALL HROPEN(LUNHBK, 'MYHIST', CHBNAM, 'N', 1024, IERR)
      END IF
*
*-- Initialize graphics
*
      CALL UHTOC(LPSNAM, 4, CPSNAM, NAMLEN)
      IF (CPSNAM .NE. ' ') THEN
         OPEN(LUNPS, FILE=CPSNAM,
     +               STATUS='UNKNOWN', FORM='FORMATTED')
         CALL IGMETA(-LUNPS, -111)
      END IF
*
*-- User set for run (booking histogram, etc.)
*
      CALL USSETR
*
*-- Prepare for input ntuple files
*
      WRITE(CHREP, '(''Number of ntuple files ='', I4)') NFILES
      CALL REPORT('ANALNT', 1, 'INFO')
      IF (NFILES .LE. 0) THEN
         WRITE(CHREP, '(''Number of ntuple files must be >0'')')
         CALL REPORT('ANALNT', 2, 'ERROR')
         GOTO 900
      END IF
*
      CALL HBSET('BSIZE', NRECNT, IERR)
      IF (IERR .NE. 0) THEN
         WRITE(CHREP, '(''Error in HBSET:'', I4)') IERR
         CALL REPORT('ANALNT', 3, 'ERROR')
         GOTO 900
      END IF
*
*-- Loop over input ntuple files
*
      IFILE = 1
      NEVALL = 0
  100 CONTINUE
*
*-- Open a ntuple file
*
      IEVENT = 0
*
      CALL HROPEN(LUNNT, 'HISTO', CFILES(IFILE), ' ', NRECNT, IERR)
      IF (IERR .NE. 0) THEN
         WRITE(CHREP, '(''Error in HROPEN:'', I4)') IERR
         CALL REPORT('ANALNT', 4, 'ERROR')
         GOTO 500
      END IF
      CALL HRIN(IDNTPL, 999999, 0)
      CALL HBNAME(IDNTPL, ' ', 0, '$CLEAR')
      CALL HBNAME(IDNTPL, BLKEVT, EVENT,  '$SET')
      CALL HBNAME(IDNTPL, BLKBEM, EIN,    '$SET')
      CALL HBNAME(IDNTPL, BLKITR, DEXE,   '$SET')
      CALL HBNAME(IDNTPL, BLKLPM, NPE,    '$SET')
      CALL HBNAME(IDNTPL, BLKSUM, NTOTPE, '$SET')
      CALL HBNAME(IDNTPL, BLKDEP, NDEPO,  '$SET')
*
*-- Check number of events in this ntuple file
*
      CALL HNOENT(IDNTPL, NEVENT)
      WRITE(CHREP, '(''Reading '', A)') CFILES(IFILE)
      CALL REPORT('ANALNT', 5, 'INFO')
      WRITE(CHREP, '(''Number of events to read:'', I8)') NEVENT
      CALL REPORT('ANALNT', 6, 'INFO')
*
*-- Loop over events in the ntuple file
*
  200 CONTINUE
*
      IF (IEVENT .EQ. 0) THEN
         CALL HGNT(IDNTPL, IEVENT+1, IERR)
      ELSE
         CALL HGNTF(IDNTPL, IEVENT+1, IERR)
      END IF
      IF (IERR .NE. 0) THEN
         WRITE(CHREP, '(''Error in HGNT/HGNTF:'', I4)') IERR
         CALL REPORT('ANALNT', 7, 'ERROR')
         GOTO 500
      END IF
      IEVENT = IEVENT + 1
      NEVALL = NEVALL + 1
*
*-- User analysis
*
      CALL USBAT
*
*-- Go process the next event
*
      IF (IEVENT .LT. NEVENT) GOTO 200
*
*-- End of an input ntuple file
*
  500 CONTINUE
      WRITE(CHREP, '(''End of file: # of events analyzed ='', I8)')
     +   IEVENT
      CALL REPORT('ANALNT', 8, 'INFO')
      CALL HREND('HISTO')
      CLOSE(LUNNT)
*
      IF (IFILE .LT. NFILES) THEN
         IFILE = IFILE + 1
         GOTO 100
      END IF
*
*-- End of all input ntuple files
*
      WRITE(CHREP, '(''Total number of events analyzed ='', I10)')
     +   NEVALL
      CALL REPORT('ANALNT', 9, 'INFO')
*
  900 CONTINUE
*
*-- Call a user routine for the end of job
*
      CALL USFIN
*
*-- Print and/or save histograms
*
      CALL HCDIR('//PAWC', ' ')
      CALL HISTDO
*
      CALL UHTOC(LHBNAM, 4, CHBNAM, NAMLEN)
      IF (CHBNAM .NE. ' ') THEN
         CALL HCDIR('//PAWC', ' ')
         CALL HCDIR('//MYHIST', ' ')
         CALL HROUT(0, ICYCLE, 'NT')
         CALL HREND('HISTO')
         CALL HCDIR('//PAWC', ' ')
      END IF
*
*-- Print REPORT summary
*
      CALL PRIREP
*
  999 CONTINUE
      STOP
      END
*
      SUBROUTINE FFUSER(KEY)
*.
*...FFUSER   Interpret FFREAD cards starting with an asterisk.
*.           Only '*FILE ...' is supported.
*.
*. SEQUENCE  : RCREP  UCNTRL
*. CALLS     : UHTOC
*. CALLED    : FFGO
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.00
*. CREATED   : 14-Apr-00
*. LAST MOD  : 14-Apr-00
*.
*. Modification Log.
*. 14-Apr-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's usrff.F.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "rcrep.inc"
#include "ucntrl.inc"
*
      INTEGER KEY(*)
*
      CHARACTER*4 CKEY
      CHARACTER*80 CFINAM, SPACES, SYSCOM
      INTEGER I, NFILE0
*
      CALL UHTOC(KEY, 4, CKEY, 4)
*
      IF (CKEY .EQ. 'FILE') THEN
*
*--      '*FILE' card
*
         NFILE0 = NFILES
         CALL UHTOC(LFINAM, 4, CFINAM, 80)
         CFINAM = SPACES(CFINAM, 1)
         IF (INDEX(CFINAM, '*') .GT. 0) THEN
*           Wild card spec. found
            WRITE(SYSCOM, 1010) CFINAM(1:60)
 1010       FORMAT('/bin/ls ', A60, ' > temp.file')
            SYSCOM = SPACES(SYSCOM, 1)
            CALL SYSTEM(SYSCOM)
            OPEN(UNIT=81, FILE='temp.file', STATUS='OLD')
            DO 20 I = 1, MXFILE
               IF(NFILES .GE. MXFILE) THEN
                  WRITE(CHREP,
     +               '(''Too many input files.  Max. ='', I5)') MXFILE
                  CALL REPORT('FFUSER', 1, 'ERROR')
                  GOTO 999
               END IF
               READ(81, '(A)', ERR=810, END=30) CFILES(NFILES+1)
               NFILES = NFILES + 1
   20       CONTINUE
*
   30       CONTINUE
            CLOSE(UNIT=81, STATUS='DELETE')
            IF (NFILES .EQ. NFILE0) THEN
               WRITE(CHREP, '(A, '' not found'')') CFINAM(1:60)
               CALL REPORT('FFUSER', 3, 'ERROR')
            END IF
         ELSE
            NFILES = NFILES + 1
            CFILES(NFILES) = CFINAM
         END IF
         CALL VBLANK(LFINAM, NAMLWO)
      END IF
*
      GOTO 999
*
*-- Errors
*
  810 CONTINUE
      WRITE(CHREP, '(''Error in reading temp.file'')')
      CALL REPORT('FFUSER', 2, 'ERROR')
*
  999 CONTINUE
      RETURN
      END
*
      SUBROUTINE REPORT(CROUT, IDMESS, CSEVER)
*.
*...REPORT   Fake ROPE's REPORT facility
*.
*. SEQUENCE  : RCREP  UCNTRL
*. CALLS     : None
*. CALLED    : Many routines
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.00
*. CREATED   : 08-May-00
*. LAST MOD  : 08-May-00
*.
*. Modification Log.
*. 08-May-00   T.Mashimo       (V1.00) First version for ANALNT.
*.                             gmflag.inc -> ucntrl.inc.
*. 13-Apr-00   T.Mashimo       Change report.inc to rcrep.inc.
*.                             Change LTHOUT to LUNREP and
*.                             add gmflag.inc.
*. 11-Mar-93   T.Mori          A modified copy created in MDLIB
*.                             (mdst scan).
*. 06-Apr-92   T.Mori          Prints a caution to suppress the messages
*. 08-Oct-90   T.Mori          Entry THXREP prints out a summary.
*. 27-Sep-90   T.Mori          Create for mDST analysis.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "ucntrl.inc"
#include "rcrep.inc"
*
      INTEGER MAXSAV,MAXOUT
      PARAMETER (MAXSAV=500,MAXOUT=20)
      CHARACTER*(*) CSEVER
      CHARACTER*(*) CROUT
      CHARACTER*1   SESAVE(MAXSAV),SEVERE(6,2)
      CHARACTER*6   PNAME,PSAVE(MAXSAV)
      CHARACTER*80  COMME,COSAVE(MAXSAV)
      INTEGER IDMESS,IDSAVE(MAXSAV),ICSAVE(MAXSAV),I,J
      INTEGER NSAVE
      SAVE ICSAVE,PSAVE,IDSAVE,COSAVE,SESAVE
      SAVE NSAVE,SEVERE
      DATA NSAVE / 0/
      DATA SEVERE /'C','F','E','W','I','S',
     +             'c','f','e','w','i','s'/
*
      WRITE(COMME,'(A80)') CHREP
      WRITE(PNAME,'(A6)') CROUT
*
      DO 100 I=1,NSAVE
        IF(PNAME.EQ.PSAVE(I).AND.IDMESS.EQ.IDSAVE(I)) THEN
          ICSAVE(I)=ICSAVE(I)+1
          IF(ICSAVE(I).LE.MAXOUT) THEN
            GOTO 110
          ELSE
            RETURN
          END IF
        END IF
  100 CONTINUE
      NSAVE=NSAVE+1
      PSAVE(NSAVE)=PNAME
      IDSAVE(NSAVE)=IDMESS
      COSAVE(NSAVE)=COMME
      SESAVE(NSAVE)=CSEVER(1:1)
      ICSAVE(NSAVE)=1
  110 CONTINUE
*
      IF(ICSAVE(I).EQ.MAXOUT) WRITE(LUNREP,1010)
      WRITE(LUNREP,1000) PNAME,IDMESS,CSEVER(1:1),IEVENT,COMME
*
      RETURN
      ENTRY PRIREP
*
*...PRIREP   Prints out REPORT messages at end of job
*
      WRITE(LUNREP,5010)
      DO 510 J=1,6
      DO 520 I=1,NSAVE
        IF(SESAVE(I).EQ.SEVERE(J,1).OR.SESAVE(I).EQ.SEVERE(J,2)) THEN
          WRITE(LUNREP,5020) ICSAVE(I),PSAVE(I),SESAVE(I),COSAVE(I)
        END IF
  520 CONTINUE
  510 CONTINUE
      WRITE(LUNREP,5090)
*
      RETURN
*
 1000 FORMAT(' ',A,'-',I4,'- ',A,'  ',I6,'  ',A)
 1010 FORMAT(' REPORT-I- The following message will be suppressed : ')
 5010 FORMAT(' '/' ',27('-'),' Report Message Summary ',27('-')/' ')
 5020 FORMAT(' ',I6,' ',A,' ',A,' ',A)
 5090 FORMAT(' '/' ',27('-'),'------------------------',27('-')/' ')
      END
