      SUBROUTINE USINIT
*.
*...USINIT   User private initialization routine
*.
*. SEQUENCE  : DECLARE
*. CALLS     : HBOOK1 HBOOK2 HCDIR
*. CALLED    : Main
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.01
*. CREATED   : 08-May-00
*. LAST MOD  : 04-Jul-02
*.
*. Modification Log.
*. 04-Jul-02   K.Ozone         (V1.01) Changed ZFIRST to XINTR(3)
*. 08-May-00   T.Mashimo       (V1.00) First version (dummy).
*.
*.**********************************************************************
*.
#include "declare.inc"
*
*-- Set default parameters
*
*-- Define private FFREAD data cards
*
  999 CONTINUE
      RETURN
      END
*
      SUBROUTINE USSETR
*.
*...USSETR   Setting for run
*.
*. SEQUENCE  : DECLARE
*. CALLS     : None
*. CALLED    : Main
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.00
*. CREATED   : 08-May-00
*. LAST MOD  : 08-May-00
*.
*. Modification Log.
*. 08-May-00   T.Mashimo       (V1.00) First version for "analnt".
*.
*.**********************************************************************
*.
#include "declare.inc"
*
*-- Initialize parameters according to FFREAD data cards
*
*-- Book histograms
*
      CALL HCDIR('//PAWC', ' ')
*
      CALL HBOOK1(  1, 'NDEPO',
     +                 100, 0.0, 1000.0, 0.)
*
      CALL HBOOK1(101, 'Total # of p.e. generated (NPEGEN)',
     +                 100, 0.0, 200000., 0.)
      CALL HBOOK1(111, 'Total # of p.e. detected (NSUM)',
     +                 100, 0.0, 100000., 0.)
      CALL HBOOK1(112, 'Total # of p.e. detected (NSUM)',
     +                 100, 47000., 57000., 0.)
      CALL HBOOK1(121, 'Z of 1st interaction (XINTR(3))',
     +                 100, -12.0,  38.0, 0.)
      CALL HBOOK1(122, 'Z of 1st conversion (XCONV(3))',
     +                 100, -12.0,  38.0, 0.)
*
      CALL HBOOK2(201, 'Total # of p.e. vs. Z of 1st conversion',
     +                 100, 0.0,  50.0, 40, 0., 60000., 0.)
      CALL HBOOK1(211, 'Total # of p.e.  2.0<(Z of 1st conv.)<50.0',
     +                 100, 47000., 57000., 0.)
      CALL HBOOK1(212, 'Total # of p.e.  5.0<(Z of 1st conv.)<50.0',
     +                 100, 47000., 57000., 0.)
      CALL HBOOK1(213, 'Total # of p.e. 10.0<(Z of 1st conv.)<50.0',
     +                 100, 47000., 57000., 0.)
      CALL HBOOK1(214, 'Total # of p.e. 15.0<(Z of 1st conv.)<50.0',
     +                 100, 47000., 57000., 0.)
*
  999 CONTINUE
      RETURN
      END
*
      SUBROUTINE USBAT
*.
*...USBAT    User analysis routine
*.
*. SEQUENCE  : DECLARE
*. CALLS     : None
*. CALLED    : Main
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.00
*. CREATED   : 08-May-00
*. LAST MOD  : 08-May-00
*.
*. Modification Log.
*. 08-May-00   T.Mashimo       (V1.00) First version.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"
*
      CALL HCDIR('//PAWC', ' ')
*
      CALL HF1(  1, FLOAT(NDEPO),   1.)
      CALL HF1(101, FLOAT(NTOTPE),  1.)
      CALL HF1(111, FLOAT(NSUM),    1.)
      CALL HF1(112, FLOAT(NSUM),    1.)
      CALL HF1(121, XINTR(3),         1.)
      CALL HF1(122, XCONV(3),       1.)
      CALL HF2(201, XCONV(3), FLOAT(NSUM), 1.)
      IF (XCONV(3) .LT. 50.0) THEN
         IF (XCONV(3) .GT.  2.0) CALL HF1(211, FLOAT(NSUM), 1.)
         IF (XCONV(3) .GT.  5.0) CALL HF1(212, FLOAT(NSUM), 1.)
         IF (XCONV(3) .GT. 10.0) CALL HF1(213, FLOAT(NSUM), 1.)
         IF (XCONV(3) .GT. 15.0) CALL HF1(214, FLOAT(NSUM), 1.)
      END IF
*
  999 CONTINUE
      RETURN
      END
*
      SUBROUTINE USFIN
*.
*...USFIN    Called at the end of job
*.
*. SEQUENCE  : DECLARE
*. CALLS     : None
*. CALLED    : Main
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.00
*. CREATED   : 08-May-00
*. LAST MOD  : 08-May-00
*.
*. Modification Log.
*. 08-May-00   T.Mashimo       (V1.00) First version (dummy).
*.
*.**********************************************************************
*.
#include "declare.inc"
*
  999 CONTINUE
      RETURN
      END
