      SUBROUTINE USKINE
*.
*...USKINE   User routine to generate kinematics
*.
*. SEQUENCE  : GCONST GCKINE RCREP  USCHKM
*. CALLS     : REPORT
*. CALLED    : GUKINE
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.00
*. CREATED   : 07-May-00
*. LAST MOD  : 07-May-00
*.
*. Modification Log.
*. 07-May-00   T.Mashimo       (V1.00) First version for "chkmat".
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "geant321/gconst.inc"
#undef CERNLIB_GEANT321_GCONST_INC
#undef CERNLIB_GEANT321_GTCONS_INC
#include "geant321/gckine.inc"
#undef CERNLIB_GEANT321_GCKINE_INC
#undef CERNLIB_GEANT321_GTKINE_INC
#include "rcrep.inc"
#include "uschkm.inc"
*
      INTEGER NVERT, NT
      REAL    PUSER, THETA, COSTH, SINTH, PHI, PLAB(3)
*
      IF (IKINE .NE. 0) THEN
         WRITE(CHREP, '(A)') 'The 1st word of KINE data card must be 0.'
         CALL REPORT('USKINE', 1, 'ERROR')
         GOTO 900
      END IF
*
      CALL GSVERT(PKINE, 0, 0, 0, 0, NVERT)
      IF (NVERT .LE. 0) THEN
         WRITE(CHREP, '(''GSVERT: NVERT = '', I10)') NVERT
         CALL REPORT('USKINE', 2, 'ERROR')
      END IF
*
      PUSER = 0.001*PKINE(4)
      THETA = PKINE(5)*DEGRAD
      PHI   = PKINE(6)*DEGRAD
      COSTH = COS(THETA)
      SINTH = SIN(THETA)
      PLAB(1) = PUSER * SINTH * COS(PHI)
      PLAB(2) = PUSER * SINTH * SIN(PHI)
      PLAB(3) = PUSER * COSTH
      CALL GSKINE(PLAB, 48, NVERT, 0., 0, NT)
      IF (NT .LE. 0) THEN
         WRITE(CHREP, '(''USKINE: NT = '', I10)') NT
         CALL REPORT('USKINE', 3, 'ERROR')
      END IF
*
  900 CONTINUE
*
*-- Initialize the variable(s) in the common /USCHKM/ for this event
*
      SMRADL = 0.0
*
  999 CONTINUE
      RETURN
      END
*
      SUBROUTINE USSTEP
*.
*...USSTEP   User routine called for each tracking step
*.
*. SEQUENCE  : GCKINE GCMATE GCSETS GCTRAK GCVOLU
*.           : USCHKM
*. CALLS     : None
*. CALLED    : GUSTEP
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.00
*. CREATED   : 07-May-00
*. LAST MOD  : 07-May-00
*.
*. Modification Log.
*. 07-May-00   T.Mashimo       (V1.00) First version for "chkmat".
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "geant321/gckine.inc"
#undef CERNLIB_GEANT321_GCKINE_INC
#undef CERNLIB_GEANT321_GTKINE_INC
#include "geant321/gcmate.inc"
#undef CERNLIB_GEANT321_GCMATE_INC
#undef CERNLIB_GEANT321_GTMATE_INC
#include "geant321/gcsets.inc"
#undef CERNLIB_GEANT321_GCSETS_INC
#undef CERNLIB_GEANT321_GTSETS_INC
#include "geant321/gctrak.inc"
#undef CERNLIB_GEANT321_GCTRAK_INC
#undef CERNLIB_GEANT321_GTTRAK_INC
#include "geant321/gcvolu.inc"
#undef CERNLIB_GEANT321_GCVOLU_INC
#undef CERNLIB_GEANT321_GTVOLU_INC
#include "uschkm.inc"
*
      INTEGER I
*
      IF (IPART .NE. 48) GOTO 900
*
      SMRADL = SMRADL + STEP/RADL
*
*-- Stop the Geantino if the requested boundary is reached
*
      DO 100 I = 1, 3
         IF (PKINE(6+I) .GE. PKINE(I) .AND.
     +       VECT(I) .GE. PKINE(6+I)  .OR.
     +       PKINE(6+I) .LT. PKINE(I) .AND.
     +       VECT(I) .LE. PKINE(6+I)) ISTOP = 1
  100 CONTINUE   
*
  900 CONTINUE
  999 CONTINUE
      RETURN
      END
*
      SUBROUTINE USOUT
*.
*...USOUT    User private routine called at the end of each event
*.
*. SEQUENCE  : USCHKM
*. CALLS     : None
*. CALLED    : GUOUT
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.00
*. CREATED   : 07-May-00
*. LAST MOD  : 07-May-00
*.
*. Modification Log.
*. 07-May-00   T.Mashimo       (V1.00) First version for "chkmat".
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "uschkm.inc"
#include "rcrep.inc"
*
      WRITE(6, 100) SMRADL
  100 FORMAT(1H1, '*** Total radiation length: ', F10.5)
*
  999 CONTINUE
      RETURN
      END
