      INTEGER NWALL,  MXPMTS
      PARAMETER (NWALL = 6, MXPMTS = 1000)
      INTEGER NAMLE, NAMLW
      PARAMETER (NAMLE = 80, NAMLW = NAMLE/4)
      INTEGER NXPMT,  NYPMT,  NZPMT,
     +        NXYPMT, NYZPMT, NZXPMT, NALPMT,
     +        NIJPMT, IJOFFS, IWOFFS
      REAL    PMTINT
      REAL    WALL,   WCATH,
     +        PMTPOS, PMTDIR
      REAL    FILL, LEVEL, QRFIDX
      INTEGER QREFON
      INTEGER QABSON
      REAL    GASTEMP, GASPRES
      REAL    HCX, HCY
      REAL    ZXEEXP
			REAL    PALPHA
      COMMON /XECGEO/ NXPMT,  NYPMT,  NZPMT,
     +        NXYPMT, NYZPMT, NZXPMT, NALPMT,
     +        NIJPMT(2,NWALL), IJOFFS(NWALL), IWOFFS(NWALL),
     +        PMTINT,
     +        WALL(NWALL), WCATH(NWALL),
     +        PMTPOS(3,MXPMTS), PMTDIR(3,MXPMTS),
     +        FILL, LEVEL, QRFIDX, QREFON, QABSON,
     +        GASTEMP, GASPRES, HCX, HCY, ZXEEXP,
     +        PALPHA
#if defined(MEGLIB_MYDOC)
***********************************************************************
*
*                  Sequence XECGEO
*                  for the geometry of the liquid Xe detector
*
***********************************************************************
*
* NXPMT  : # of PMTs in x direction
* NYPMT  : # of PMTs in y direction
* NZPMT  : # of PMTs in z direction
* NXYPMT : # of PMTs in +-z walls (=NXPMT*NYPMT)
* NYZPMT : # of PMTs in +-x walls (=NYPMT*NZPMT)
* NZXPMT : # of PMTs in +-y walls (=NZPMT*NXPMT)
* NALPMT : # of all PMTs (=2*(NXYPMT+NYZPMT+NZXPMT))
* NIJPMT(i,iw) : NIJPMT(1,iw)*NIJPMT(2,iw) = # of PMTs on iw-th wall
*                See below for how to use this.
* IJOFFS(iw)   : See below
* IWOFFS(iw)   : offset for PMT address.  See below.
* NIJPMT, IJOFFS, and IWOFFS are used in the following way;
*       DO 100 iw = 1, NWALL
*       DO 100 ix = 1, NIJPMT(1,iw)
*       DO 100 iy = 1, NIJPMT(2,iw)
*          PMT-address = ix + (iy-1)*IJOFFS(iw) + IWOFFS(iw)
*   100 CONTINUE
*
* PMTINT : distance between centers of adjacent PMTs
* WALL(iw)     : wall position, e.g. iw=1: x-coordinate of the -x wall
* WCATH(iw)    : photo-cathode position
* PMTPOS(*,i)  : (x,y,z) position of i-th PMT (center of photo-cathode)
* PMTDIR(*,i)  : dir. cosines of vector normal to the i-th cathode
* FILL         : filling factor of liquid xenon 0<FILL<1
* LEVEL        : y-coordinate of xenon surface
* QRFIDX       : refraction index of quartz
* QREFON       : switch of reflection on qurtz window
*                1:ON, 0:OFF
* QABSON       : switch of absorption on quartz
*                1:ON, 0:OFF
* GASTEMP      : temperature of gas xenon
* GASPRES      : pressure of gas xenon
* HCX          : center of realistic honeycomb (x)
* HCY          : center of realistic honeycomb (y)
* ZXEEXP       : distance between honeycomb and holder   
* PALPHA       : distance from center to Am plate
***********************************************************************
#endif
