      INTEGER MXDEXE
      PARAMETER (MXDEXE = 3000)
*
      INTEGER NINTER
      INTEGER NDEXE,  NDEXES
      REAL    X1INTR, X1CONV
      REAL    DEXESM, DEREST,
     +        CUTDES, DEXESC, XDEXE
      REAL    ORGVTX
      COMMON /XECINT/
     +        NINTER, X1INTR(3), X1CONV(3),
     +        DEXESM, DEREST,
     +        CUTDES, DEXESC,
     +        NDEXE,
     +        XDEXE(5,MXDEXE),
     +        NDEXES
#if defined(MEGLIB_MYDOC)
***********************************************************************
*
*                  Sequence XECINT
*                  for recording particle interactions in liquid Xe
*
***********************************************************************
*
* NINTER : # of interactions before conversion
* X1INTR : first interaction point
* X1CONV : photon conversion point
* DEXESM : total energy deposit in liquid Xe
* DEREST : total energy deposit other than in liquid Xe
* CUTDES : cut for DESTEP to be used for scintillation generation
* DEXESC : total energy deposit in Xe used for scintillation
* NDEXE  : # of valid entries in array XDEXE
* XDEXE(1-3,*) : x, y, z position (cm)
* XDEXE(4,*) : dE/dx (GeV) in that GEANT step (DESTEP in /GCTRAK/)
* XDEXE(5,*) : timing (sec) (TOFG in /GCTRAK/)
* NDEXES : # of XDEXE entries used for scintillation photon tracking
*
***********************************************************************
#endif
