      INTEGER ISCTRK,
     +        IPOISN,
     +        LRAYL,  IABSO,  IREFL,
     +        IDEREFL
      INTEGER NSRNDM
      INTEGER NPEGEN
      INTEGER NPEPMT, NPEWAL, NPEALL
      INTEGER RFLG
      REAL    ESCINT
      REAL    RFRIDX, VLIGHT, CRAGXQ, CRAGXV
      REAL    DRAYL,  DABSO,  EREFL
      REAL    PEGEN
      COMMON /XECSCI/
     +        ISCTRK,
     +        ESCINT, IPOISN,
     +        RFRIDX, VLIGHT,
     +        LRAYL,  DRAYL,
     +        IABSO,  DABSO,
     +        IREFL,  EREFL,
     +        NSRNDM(2),
     +        PEGEN,  NPEGEN,
     +        NPEPMT(MXPMTS), NPEWAL(NWALL), NPEALL,
     +	      RFLG, CRAGXQ, CRAGXV, IDEREFL
#if defined(MEGLIB_MYDOC)
***********************************************************************
*
*                  Sequence XECSCI
*                  for scintillation light tracking in liquid Xe
*
***********************************************************************
*
* ISCTRK : tracking of scintillation light  =1: on, =0: off
* ESCINT : one scintillation photon per dE/dx=ESCINT (in GeV)
* IPOISN : Poisson random distribution in light generation  =1: on
* RFRIDX : Refractive index of liquid Xe (1.5655+-24+-78)
* VLIGHT : light velocity in liquid Xe (cm/sec)
* LRAYL  : Rayleigh scattering  =1: on, =0: off
* DRAYL  : Rayleigh scattering length (cm)
* IABSO  : absorption  =1: on, =0: off
* DABSO  : absorption length (cm)
* IREFL  : reflection at wall  =1: on, =0: off
* EREFL  : reflection efficiency (=0.6 for Teflon)
* IDEREFL: reflection type =0: mirror, =1: diffuse
*
* PEGEN  : total # of p.e. expected times Q.E.
* NPEGEN : total # of generated scinti. photons (incl. Poisson dist.)
* NPEPMT : # of photo-electrons for each PMT
* NPEWAL : # of photo-electrons for each detector wall
* NPEALL : total # of photo-electrons
*
* RFLG   : region of photon tracking =1: xenon  =0: vacuum
* CRAGXV : critical angle between liquid xenon and vacuum (in radian)
* CRAGXV : critical angle between liquid xenon and quartz (in radian)
***********************************************************************
#endif
