      SUBROUTINE GMITMD
*.
*...GMITMD   Initialize tracking medium parameters
*.
*. SEQUENCE  : GCTMPA GMMATM RCREP
*. CALLS     : FFKEY
*. CALLED    : GMIFFR
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.03
*. CREATED   : 12-May-00
*. LAST MOD  : 21-May-00
*.
*. Modification Log.
*. 25-Jan-03   R.Sawada        (V1.06) change material of 
*.                              XPSS and XPDY to SUS304
*. 24-Jan-03   R.Sawada        (V1.05) Added HCPL ALFM ALPL
*. 23-Jan-03   R.Sawada        (V1.04) Added HCVA
*. 21-May-00   T.Mashimo       (V1.03) 'LQXE','XETA' -> 'XELQ','XEVS'.
*. 20-May-00   T.Mashimo       (V1.02) Rename LPITMD back to GMITMD
*.                             for GEM v0.03.
*. 16-May-00   T.Mashimo       (V1.01) Rename GMITMD to LPITMD.
*.                             Add tracking media for lproto.
*.                             Now all media can be under mag. field.
*. 12-May-00   T.Mashimo       (V1.00) First version (for GEM v0.02).
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "gmmatm.inc"
#include "gctmpa.inc"
#include "rcrep.inc"
*
      INTEGER I, J
      INTEGER IPARMS(3,MXTMED)
      REAL    RPARMS(6,MXTMED)
*
      DATA    (IPARMS(I, TMMEG),  I = 1, 3) /     15, 0, -1 /
      DATA    (RPARMS(I, TMMEG),  I = 1, 6) /
     +         -1.0, 10.0, 0.500, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMPIPE), I = 1, 3) / MAGAS1, 0, -1 /
      DATA    (RPARMS(I, TMPIPE), I = 1, 6) /
     +         -1.0,  0.1, 0.500, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMCOAL), I = 1, 3) /      9, 0, -1 /
      DATA    (RPARMS(I, TMCOAL), I = 1, 6) /
     +         -1.0,  0.1, 0.500, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMVACU), I = 1, 3) /     16, 0, -1 /
      DATA    (RPARMS(I, TMVACU), I = 1, 6) /
     +         -1.0,  0.1, 0.500, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMVACS), I = 1, 3) /     16, 1, -1 /
      DATA    (RPARMS(I, TMVACS), I = 1, 6) /
     +         -1.0,  0.1, 0.500, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMTRGT), I = 1, 3) / MAMYLR, 0, -1 /
      DATA    (RPARMS(I, TMTRGT), I = 1, 6) /
     +         -1.0,  0.001, 0.0001, 0.001, 0.00001, 0.0001 /
      DATA    (IPARMS(I, TMHE),   I = 1, 3) / MAGAS3, 0, -1 /
      DATA    (RPARMS(I, TMHE),   I = 1, 6) /
     +         -1.0,  0.1, 0.500, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMCGAS), I = 1, 3) / MAGAS1, 1, -1 /
      DATA    (RPARMS(I, TMCGAS), I = 1, 6) /
     +         -1.0,  0.1, 0.500, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMCWL1), I = 1, 3) / MAKAPT, 0, -1 /
      DATA    (RPARMS(I, TMCWL1), I = 1, 6) /
     +         -1.0,  0.001, 0.0001, 0.001, 0.00001, 0.0001 /
      DATA    (IPARMS(I, TMCWL2), I = 1, 3) / MAKAPT, 0, -1 /
      DATA    (RPARMS(I, TMCWL2), I = 1, 6) /
     +         -1.0,  0.001, 0.0001, 0.001, 0.00001, 0.0001 /
      DATA    (IPARMS(I, TMTFSC), I = 1, 3) / MATFSC, 1, -1 /
      DATA    (RPARMS(I, TMTFSC), I = 1, 6) /
     +         -1.0,  0.1, 0.500, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMXEVS), I = 1, 3) /     10, 0, -1 /
      DATA    (RPARMS(I, TMXEVS), I = 1, 6) /
     +         -1.0,  0.1, 0.500, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMXELQ), I = 1, 3) / MAXELQ, 1, -1 /
      DATA    (RPARMS(I, TMXELQ), I = 1, 6) /
     +         -1.0,  0.1, 0.500, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMXEVA), I = 1, 3) /     16, 0, -1 /
      DATA    (RPARMS(I, TMXEVA), I = 1, 6) /
     +         -1.0,  0.1, 0.500, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMHCVA), I = 1, 3) /     16, 0, -1 /
      DATA    (RPARMS(I, TMHCVA), I = 1, 6) /
     +         -1.0,  0.1, 0.500, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMXEHP), I = 1, 3) /     10, 0, -1 /
      DATA    (RPARMS(I, TMXEHP), I = 1, 6) /
     +         -1.0,  0.1, 0.100, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMXEHC), I = 1, 3) / MAXEHC, 0, -1 /
      DATA    (RPARMS(I, TMXEHC), I = 1, 6) /
     +         -1.0,  0.1, 0.500, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMXEAW), I = 1, 3) /      9, 0, -1 /
      DATA    (RPARMS(I, TMXEAW), I = 1, 6) /
     +         -1.0,  0.1, 0.100, 0.050, 0.001, 0.001 /
*
      DATA    (IPARMS(I, TMXPWD), I = 1, 3) / MAQGLS, 0, -1 /
      DATA    (RPARMS(I, TMXPWD), I = 1, 6) /
     +         -1.0,  0.1, 0.100, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMXPSS), I = 1, 3) / MASUS304,  0, -1 /
      DATA    (RPARMS(I, TMXPSS), I = 1, 6) /
     +         -1.0,  0.1, 0.100, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMXPDY), I = 1, 3) / MASUS304,  0, -1 /
      DATA    (RPARMS(I, TMXPDY), I = 1, 6) /
     +         -1.0,  0.1, 0.100, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMXPGL), I = 1, 3) / MAPYRX, 0, -1 /
      DATA    (RPARMS(I, TMXPGL), I = 1, 6) /
     +         -1.0,  0.1, 0.100, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMXPBS), I = 1, 3) / MAG10,  0, -1 /
      DATA    (RPARMS(I, TMXPBS), I = 1, 6) /
     +         -1.0,  0.1, 0.100, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMXPH3), I = 1, 3) / MAPMMA, 0, -1 /
      DATA    (RPARMS(I, TMXPH3), I = 1, 6) /
     +         -1.0,  0.1, 0.100, 0.050, 0.001, 0.001 /
      DATA    (IPARMS(I, TMAMFM), I = 1, 3) / MAGOLD, 0, -1 /
      DATA    (RPARMS(I, TMAMFM), I = 1, 6) /
     +         -1.0,  0.001, 0.0001, 0.001, 0.00001, 0.0001 /
      DATA    (IPARMS(I, TMAMPL), I = 1, 3) / MASUS304, 0, -1 /
      DATA    (RPARMS(I, TMAMPL), I = 1, 6) /
     +         -1.0,  0.001, 0.0001, 0.001, 0.00001, 0.0001 /
      DATA    (IPARMS(I, TMHCPL), I = 1, 3)   / MASUS316, 0, -1 /
      DATA    (RPARMS(I, TMHCPL), I = 1, 6)   /
     +         -1.0,  0.1, 0.100, 0.050, 0.001, 0.001 /
*
*-- Initialize tracking medium parameters.
*--
*-- The meaning of "-1" for ITMPAR(3,*) (magnetic field flag)
*-- and "-1.0" for RTMPAR(4,*) (maximum field value) is as follows.
*-- An expert user can specify any parameter of any tracking medium
*-- with a TMEDxxxx data card.
*-- If the magnetic field flag and the maximum field value are not
*-- specified by the user through the TMEDxxxx data card,
*-- they will be set to the values determined by a FFREAD data card
*-- "BFIELD".
*-- If the value for ITMPAR(3,*) or RTMPAR(4,*) remains negative
*-- after GFFGO, it means that the user has not set it with the
*-- TMEDxxxx data card.
*
      DO 100 I = 1, MXTMED
         DO 10 J = 1, 3
   10    ITMPAR(J,I) = IPARMS(J,I)
         DO 20 J = 1, 6
   20    RTMPAR(3+J,I) = RPARMS(J,I)
  100 CONTINUE
*
*-- Define our FFREAD data cards
*
      CALL FFKEY('TMEDLP',   ITMPAR(1,TMMEG),  9, 'MIXED')
      CALL FFKEY('TMEDMEG',  ITMPAR(1,TMMEG),  9, 'MIXED')
      CALL FFKEY('TMEDPIPE', ITMPAR(1,TMPIPE), 9, 'MIXED')
      CALL FFKEY('TMEDCOAL', ITMPAR(1,TMCOAL), 9, 'MIXED')
      CALL FFKEY('TMEDVACU', ITMPAR(1,TMVACU), 9, 'MIXED')
      CALL FFKEY('TMEDVACS', ITMPAR(1,TMVACS), 9, 'MIXED')
      CALL FFKEY('TMEDTRGT', ITMPAR(1,TMTRGT), 9, 'MIXED')
      CALL FFKEY('TMEDHE',   ITMPAR(1,TMHE),   9, 'MIXED')
      CALL FFKEY('TMEDCGAS', ITMPAR(1,TMCGAS), 9, 'MIXED')
      CALL FFKEY('TMEDCWL1', ITMPAR(1,TMCWL1), 9, 'MIXED')
      CALL FFKEY('TMEDCWL2', ITMPAR(1,TMCWL2), 9, 'MIXED')
      CALL FFKEY('TMEDTFSC', ITMPAR(1,TMTFSC), 9, 'MIXED')
      CALL FFKEY('TMEDXEVS', ITMPAR(1,TMXEVS), 9, 'MIXED')
      CALL FFKEY('TMEDXELQ', ITMPAR(1,TMXELQ), 9, 'MIXED')
      CALL FFKEY('TMEDXEVA', ITMPAR(1,TMXEVA), 9, 'MIXED')
      CALL FFKEY('TMEDHCVA', ITMPAR(1,TMHCVA), 9, 'MIXED')
      CALL FFKEY('TMEDXEHP', ITMPAR(1,TMXEHP), 9, 'MIXED')
      CALL FFKEY('TMEDXEHC', ITMPAR(1,TMXEHC), 9, 'MIXED')
      CALL FFKEY('TMEDXEAW', ITMPAR(1,TMXEAW), 9, 'MIXED')
      CALL FFKEY('TMEDXPWD', ITMPAR(1,TMXPWD), 9, 'MIXED')
      CALL FFKEY('TMEDXPSS', ITMPAR(1,TMXPSS), 9, 'MIXED')
      CALL FFKEY('TMEDXPDY', ITMPAR(1,TMXPDY), 9, 'MIXED')
      CALL FFKEY('TMEDXPGL', ITMPAR(1,TMXPGL), 9, 'MIXED')
      CALL FFKEY('TMEDXPBS', ITMPAR(1,TMXPBS), 9, 'MIXED')
      CALL FFKEY('TMEDXPH3', ITMPAR(1,TMXPH3), 9, 'MIXED')
      CALL FFKEY('TMEDAMFM', ITMPAR(1,TMAMFM), 9, 'MIXED')
      CALL FFKEY('TMEDAMPL', ITMPAR(1,TMAMPL), 9, 'MIXED')
      CALL FFKEY('TMEDHCPL', ITMPAR(1,TMHCPL), 9, 'MIXED')
*
  999 CONTINUE
      RETURN
      END
