      SUBROUTINE GMTMED
*.
*...GMTMED   Define tracking media
*.
*. SEQUENCE  : BFFLAG GCTMPA GMMATM
*. CALLS     : GSTMED
*. CALLED    : GMGEOM
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.13
*. CREATED   : 21-Apr-00
*. LAST MOD  : 21-May-00
*.
*. Modification Log.
*. 25-Jan-03   R.Sawada        (V1.15) Added AMFM AMPL HCPL TMXPH3.
*. 23-Jan-03   R.Sawada        (V1.14) Added HCVA.
*. 21-May-00   T.Mashimo       (V1.13) 'LQXE','XETA' -> 'XELQ','XEVS'.
*. 20-May-00   T.Mashimo       (V1.12) Rename LPTMED back to GMTMED
*.                             for GEM v0.03.
*. 16-May-00   T.Mashimo       (V1.11) Rename GMTMED (for GEM v0.02)
*.                             to LPITMD.  Add tracking media for LP.
*. 12-May-00   T.Mashimo       (V1.10) Improved handling of mag. field.
*. 21-Apr-00   T.Mashimo       (V1.00) First version.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "gmmatm.inc"
#include "gctmpa.inc"
#include "bfflag.inc"
*
      INTEGER NTMEDS
      PARAMETER (NTMEDS = 27)
      INTEGER ITMEDS(NTMEDS)
      CHARACTER*20 CTMEDS(NTMEDS)
*
      INTEGER I, ITMED
*
      DATA    (ITMEDS(I), CTMEDS(I), I = 1, 10) /
     +        TMMEG,  'MEG VOLUME          ',
     +        TMPIPE, 'INSIDE BEAM PIPE    ',
     +        TMCOAL, 'COIL ALUMINIUM      ',
     +        TMVACU, 'VACUUM WITH B       ',
     +        TMVACS, 'VACUUM WITH B (DET) ',
     +        TMTRGT, 'MYLAR TARGET        ',
     +        TMHE,   'HE AROUND TARGET    ',
     +        TMCGAS, 'CHAMBER GAS         ',
     +        TMCWL1, 'CHAMBER CENTER WALL ',
     +        TMCWL2, 'CHAMBER OUTER WALL  '
     +        /
      DATA    (ITMEDS(I), CTMEDS(I), I = 11, 21) /
     +        TMTFSC, 'TOF SCINTILLATOR    ',
     +        TMXEVS, 'XE VESSEL WALL      ',
     +        TMXELQ, 'LIQUID XENON        ',
     +        TMXEVA, 'VACUUM IN XE VESSEL ',
     +        TMHCVA, 'VACUUM IN HONEYCOMB ',
     +        TMXEHP, 'HONEYCOMB PLATE     ',
     +        TMXEHC, 'HONEYCOMB CORE      ',
     +        TMXEAW, 'AL WINDOW OF VESSEL ',
     +        TMXPWD, 'XE PMT SILICA WINDOW',
     +        TMXPSS, 'XE PMT SUS TUBE     ',
     +        TMXPDY, 'XE PMT SUS DYNODE   '
     +        /
      DATA    (ITMEDS(I), CTMEDS(I), I = 22, NTMEDS) /
     +        TMXPGL, 'XE PMT GLASS STEM   ',
     +        TMXPBS, 'XE PMT G10 BASE     ',
     +        TMXPH3, 'XE PMT Acrilic  BASE',
     +        TMAMPL, 'SUS304 source plate ',
     +        TMAMFM, 'Gold source film    ',
     +        TMHCPL, 'SUS316 honeycomb    '
     +        /
*
*-- Define tracking media
*
      DO 100 I = 1, NTMEDS
         ITMED = ITMEDS(I)
*        For the meaning of the following two lines,
*        see the comment of subroutine GMITMD.
         IF (ITMPAR(3,ITMED) .LT. 0)   ITMPAR(3,ITMED) = IBFLD
         IF (RTMPAR(4,ITMED) .LT. 0.0) RTMPAR(4,ITMED) = BFLDM
*
         CALL GSTMED(ITMEDS(I), CTMEDS(I),
     +               ITMPAR(1,ITMED), ITMPAR(2,ITMED),
     +               ITMPAR(3,ITMED), RTMPAR(4,ITMED),
     +               RTMPAR(5,ITMED), RTMPAR(6,ITMED),
     +               RTMPAR(7,ITMED), RTMPAR(8,ITMED),
     +               RTMPAR(9,ITMED), 0, 0)
  100 CONTINUE
*
  999 CONTINUE
      RETURN
      END
