      SUBROUTINE GUOUT
*.
*...GUOUT    User routine called at the end of each event
*.
*. SEQUENCE  : GCFLAG GCONST GCLIST GCKINE
*.           : LPFLAG NTUPLE RCREP  XECGEO XECINT XECSCI
*. CALLS     : GDAXIS GDRAWC GDRAWT GDXYZ
*.           : HFNT   ICLRWK USOUT  XEPLEV XSBGN  XSTRAK
*. CALLED    : GTRIG
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.03
*. CREATED   : 07-May-00
*. LAST MOD  : 06-Jul-02
*.
*. Modification Log.
*. 04-Feb-03   R.Sawada        (V1.06) enabled to trace phton from 
*.                             18.6<abs(x)<18.9, 18.6<abs(y)<18.9,
*.                             -0.3<z<0.0, 49.6<z<49.9
*. 25-Jan-03   R.Sawada        (V1.05) Added XDEPOS(5)
*. 23-Jan-03   R.Sawada        (V1.04) Modified LP2EXP
*. 06-Jul-02   K.Ozone         (V1.03) Changed ZFIRST to XINTR(3).
*.                             Change XDEPO to XDEPOS. Now XDEPO
*.                             means the 1st values of XDEPOS.
*.                             Added CADC in LP experiment.
*.                             Added various same sums as experiment.
*. 28-Nov-00   T.Mashimo       (V1.02) Fix a bug pointed out by Ozone;
*.                             in the event display XCONV was used
*.                             instead of X1CONV.
*. 16-May-00   T.Mashimo       (V1.01) Initial volume name MEG -> LP.
*. 07-May-00   T.Mashimo       (V1.00) 1st version based on T. Mori's
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "geant321/gckine.inc"
#include "geant321/gconst.inc"
#include "geant321/gcflag.inc"
#include "geant321/gclist.inc"
#include "lpflag.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "xecsci.inc"
#include "ntuple.inc"
#include "rcrep.inc"
*
      INTEGER I, J
      CHARACTER*35 COMMNT
*
      REAL    ADCV
      INTEGER LP2EXP(264)
      DATA    LP2EXP /
     +      48,  64,  16,   7,  55,  39,           !right
     +      36,  52,   4,  11,  59,  43,
     +      88,  92,  96,  83,  79,  75,
     +     124, 128,  72,  67, 119, 147,
     +     180, 140, 144, 135, 131, 175,
     +     164, 168, 172, 159, 155, 151,
     +      -1, 192, 196, 187, 183,  -1,
     +      -1,  -1,  -1,  -1,  -1,  -1,
     +      37,  53,   5,  14,  62,  46,           !left
     +      41,  57,   9,   2,  50,  34,
     +      73,  77,  81,  94,  90,  86,
     +     145, 117,  65,  70, 126, 122,
     +     173, 129, 133, 142, 138, 178,
     +     149, 153, 157, 170, 166, 162,
     +      -1, 181, 185, 194, 190,  -1,
     +      -1,  -1,  -1,  -1,  -1,  -1,
     +      40,  44,  76, 148, 176, 152,  -1,  -1, !bottom
     +      56,  60,  80, 120, 132, 156, 184,  -1,
     +       8,  12,  84,  68, 136, 160, 188,  -1,
     +      15,   3,  95,  71, 143, 171, 195,  -1,
     +      63,  51,  91, 127, 139, 167, 191,  -1,
     +      47,  35,  87, 123, 179, 163,  -1,  -1,
     +      45,  33,  85, 121, 177, 161,  -1,  -1, !top
     +      61,  49,  89, 125, 137, 165, 189,  -1,
     +      13,   1,  93,  69, 141, 169, 193,  -1,
     +       6,  10,  82,  66, 134, 158, 186,  -1,
     +      54,  58,  78, 118, 130, 154, 182,  -1,
     +      38,  42,  74, 146, 174, 150,  -1,  -1,
     +     111, 109, 107, 105, 103, 101,           !front
     +     113,  27,  23,  19,  25,  99,
     +     115,  17,  31,  29,  21,  97,
     +     102,  22,  30,  32,  18, 100,
     +     104,  26,  20,  24,  28,  98,
     +     106, 108, 110, 112, 114, 116,
     +      -1, 203, 201, 199, 197,  -1,           !back
     +     215, 213, 211, 209, 207, 205,
     +     227, 225, 223, 221, 219, 217,
     +     208, 206, 204, 202, 200, 198,
     +     220, 218, 216, 214, 212, 210,
     +      -1, 228, 226, 224, 222,  -1/
*
*-- Draw this event
*
      IF (NPLOT .GT. 0 .AND.
     +    IEVENT .GE. LPLOT(1) .AND. IEVENT .LE. LPLOT(2)) THEN
         CALL ICLRWK(0, 0)  ! clear
*
         CALL GDRAWC('LP  ', 3, -5., 10.5, 15., 0.2, 0.2)    ! y-x plot
         CALL GDAXIS(-20., -20., -25., 8.)
         CALL GDXYZ(0)
         WRITE(COMMNT, '(''Converted:'',3F8.2)') (X1CONV(I),I=1,3)
*         CALL GDRAWC('LP  ', 2, 0.0, 7.5, 15., 0.2, 0.2)    ! x-z plot
*         CALL GDAXIS(-20., -20., -25., 8.)
*         CALL GDXYZ(0)
*         WRITE(COMMNT, '(''Converted:'',3F8.2)') (X1CONV(I),I=1,3)
*
         CALL GDRAWC('LP  ',1, 0.0, 7.5,  5., 0.2, 0.2)    ! y-z plot
         CALL GDAXIS(-20., -20., -25., 8.)
         CALL GDXYZ(0)
*
         WRITE(COMMNT, '(''Converted:'',3F8.2)') (X1CONV(I),I=1,3)
         CALL GDRAWT( 5.0,  9.8, COMMNT, 0.3, 0., 2, -1)
*
**       CALL ICLRWK(0, 0)  ! clear
*
**       CALL GDRAWC('LP  ', 2, 3.0, 20.0, 10., 1.0, 1.0)    ! x-z plot
      END IF
*
*-- No conversion or interaction 
*
      IF (X1INTR(3) .GT. 500.) THEN 
         WRITE(CHREP, '(''No interaction occurred'')') 
         CALL REPORT('GUOUT', 1, 'WARNING')
      END IF
      IF (X1CONV(3) .GT. 500.) THEN 
         WRITE(CHREP, '(''No conversion occurred'')') 
         CALL REPORT('GUOUT', 2, 'INFO')
      END IF
*
*-- Scintillation light tracking
*
      IF (ISCTRK .GT. 0) THEN
         CALL XSBGN
         DO 100 I = 1, NDEXE
            IF (XDEXE(1,I) .GT. (WALL(1)-0.3) .AND.
     +          XDEXE(1,I) .LT. (WALL(2)+0.3) .AND.
     +          XDEXE(2,I) .GT. (WALL(3)-0.3) .AND.
     +          XDEXE(2,I) .LT. (WALL(4)+0.3) .AND.
     +          XDEXE(3,I) .GT. (WALL(5)-0.3) .AND.
     +          XDEXE(3,I) .LT. (WALL(6)+0.3)) THEN
               NDEXES = NDEXES + 1
               CALL XSTRAK(XDEXE(1,I))
            END IF
  100    CONTINUE
      END IF
*
*-- Print the p.e. distribution graphically
*
**    CALL XEPLEV
*
*-- Fill ntuple
*
      IF (NTUPON .EQ. 1) THEN
         DEXE   = DEXESM
         DEPMT  = DEREST
         XCONV(1) = X1CONV(1)
         XCONV(2) = X1CONV(2)
         XCONV(3) = X1CONV(3)
         XINTR(1) = X1INTR(1)
         XINTR(2) = X1INTR(2)
         XINTR(3) = X1INTR(3)
         NDEPO  = NDEXE
         DO 210 I = 1, NDEPO
         DO 210 J = 1, 5
            XDEPOS(J,I) = XDEXE(J,I)
  210    CONTINUE
         XDEPO(1) = XDEPOS(1,1)
         XDEPO(2) = XDEPOS(2,1)
         XDEPO(3) = XDEPOS(3,1)
         XDEPO(4) = XDEPOS(4,1)
         XDEPO(5) = XDEPOS(5,1)
         NTOTPE = NPEGEN
         NSUM   = NPEALL
         DO 220 I = 1, NALPMT
            NPE(I) = NPEPMT(I)
  220    CONTINUE
         IF (EXPOUT .EQ. 1) THEN
            QSUM     = 0.0
            Q_RIGHT  = 0.0
            Q_LEFT   = 0.0
            Q_BOTTOM = 0.0
            Q_TOP    = 0.0
            Q_FRONT  = 0.0
            Q_BACK   = 0.0
            DO 230 I = 1, 264
               IF (LP2EXP(I) .NE. -1) THEN
                  ADCV = FLOAT(NPE(I))
                  CADC(LP2EXP(I)) = ADCV
                  QSUM = QSUM + ADCV
                  IF (I .LE. 48) THEN
                     Q_RIGHT = Q_RIGHT + ADCV
                  ELSE IF (I .LE. 96) THEN
                     Q_LEFT = Q_LEFT + ADCV
                  ELSE IF (I .LE. 144) THEN
                     Q_BOTTOM = Q_BOTTOM + ADCV
                  ELSE IF (I .LE. 192) THEN
                     Q_TOP = Q_TOP + ADCV
                  ELSE IF (I .LE. 228) THEN
                     Q_FRONT = Q_FRONT + ADCV
                  ELSE
                     Q_BACK = Q_BACK + ADCV
                  END IF
               END IF
  230       CONTINUE
         END IF
         DO 240 I = 1, NWALL
            NPEW(I) = NPEWAL(I)
  240    CONTINUE
*
         CALL HFNT(IDNTPL)
      END IF
*
*-- Call user routine
*
      CALL USOUT
*
      RETURN
      END
