       SUBROUTINE GUSTEP
*.
*...GUSTEP   User routine called for each tracking step
*.
*. SEQUENCE  : GCFLAG GCLIST GCKINE GCKING GCTMED GCTRAK GCNUM  GCVOLU
*.           : GMMATM LPFLAG RCREP  XECGEO XECINT
*. CALLS     : GSKING GSXYZ  REPORT UHTOC
*. CALLED    : GTRACK
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.02
*. CREATED   : 06-May-00
*. LAST MOD  : 22-May-00
*.
*. Modification Log.
*. 22-May-00   T.Mashimo       (V1.02) 'LQXE' -> 'XELQ'.
*. 10-May-00   T.Mashimo       (V1.01) Fix a bug on X1INTR;
*.                             Mechanism 'NEXT' was not skipped.
*. 06-May-00   T.Mashimo       (V1.00) 1st version.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "geant321/gcflag.inc"
#include "geant321/gclist.inc"
#include "geant321/gctrak.inc"
#include "geant321/gctmed.inc"
#include "geant321/gcvolu.inc"
#include "geant321/gckine.inc"
#include "geant321/gcking.inc"
#include "geant321/gcnum.inc"
#include "lpflag.inc"
#include "gmmatm.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "rcrep.inc"
*
      INTEGER I, IMECHA
      CHARACTER*4 CMECHA
*
*-- Debug event
*
      CALL GDEBUG
*
*-- First conversion occurred?
*

      IF (ITRA .EQ. 1 .AND. IPART .EQ. 1 .AND.
     +   X1CONV(3) .GT. 1.E5) THEN
*
         IF (NMEC .EQ. 0) THEN
*           This means start of the tracking ("new volume").
*           See SBR GPCXYZ for how to use NMEC, LMEC, etc. in /GCTRAK/.
            GOTO 100
         END IF
*
         I = LMEC(1)
         IF (I .LE. MAXMEC) THEN
            IMECHA = NAMEC(I)
         ELSE IF (I-100 .LE. MAXME1 .AND. I-100 .GT. 0) THEN
            IMECHA = NAMEC1(I-100)
         ELSE
            CALL UCTOH('????', IMECHA, 4, 4)
         END IF
         CALL UHTOC(IMECHA, 4, CMECHA, 4)
*
         IF (CMECHA .EQ. 'NEXT') GOTO 100
*
         NINTER = NINTER + 1
         IF (NINTER .EQ. 1) THEN
            DO 50 I = 1, 3
               X1INTR(I) = VECT(I)
   50       CONTINUE
         END IF
*
         IF (CMECHA .EQ. 'PAIR') THEN
            DO 70 I = 1, 3
               X1CONV(I) = VECT(I)
   70       CONTINUE
         END IF
      END IF
*
  100 CONTINUE

*
*-- Store deposited energy and position
*
**  For debugging
**    IF (NMEC .EQ. 0) THEN
**       CMECHA = 'NULL'
**    ELSE
**       I = LMEC(1)
**       IF (I .LE. MAXMEC) THEN
**          IMECHA = NAMEC(I)
**       ELSE IF (I-100 .LE. MAXME1 .AND. I-100 .GT. 0) THEN
**          IMECHA = NAMEC1(I-100)
**       ELSE
**          CALL UCTOH('????', IMECHA, 4, 4)
**       END IF
**       CALL UHTOC(IMECHA, 4, CMECHA, 4)
**    END IF
*
**    IF (CHARGE .EQ. 0.0) GOTO 900
*
      IF (NUMED .EQ. TMXELQ) THEN
*
*   Here all DESTEP are considered, regardless of whether the current
*   particle is a charged particle or a photon.
*   Even for a photon, DESTEP can be non-zero:
*     (i) shell potential energy for photo-electric effect
*    (ii) an electron to be generated by a Compton or photo-electric
*         effect has an energy less than CUTELE.
*   (iii) an electron to be generated by a photo-electric effect
*         for a <1MeV photon is judged not to be able to reach
*         the volume boundary.
*   The (iii) has a significant contribution.
*
         DEXESM = DEXESM + DESTEP
         IF (DESTEP .GT. CUTDES) THEN
            DEXESC = DEXESC + DESTEP
            NDEXE = NDEXE + 1
            IF (NDEXE .LE. MXDEXE) THEN
               XDEXE(1,NDEXE) = VECT(1)
               XDEXE(2,NDEXE) = VECT(2)
               XDEXE(3,NDEXE) = VECT(3)
               XDEXE(4,NDEXE) = DESTEP
               XDEXE(5,NDEXE) = TOFG
            ELSE
               WRITE(CHREP, '(''NDEXE exceeds MXDEXE = '', I8)') MXDEXE
               CALL REPORT('GUSTEP', 2, 'ERROR')
               NDEXE = MXDEXE
            END IF
         END IF
      ELSE                              ! anything other than Xe
         DEREST = DEREST + DESTEP
      ENDIF
*
  900 CONTINUE
*
*-- Store the created particles
*
      IF (NGKINE .GT. 0) THEN
         DO 910 I = 1, NGKINE
            IFLGK(I) = 0
  910    CONTINUE
         CALL GSKING(0)
      END IF
*
*-- Store track space points for later drawing
*
      IF (NPLOT .GT. 0. AND.
     +   IEVENT .GE. LPLOT(1) .AND. IEVENT .LE. LPLOT(2)) THEN
         IF (VECT(7) .GE. CUTXYZ/1000.) THEN
            CALL GSXYZ
         END IF
      END IF
*
*-- Call user routine
*
      CALL USSTEP
*
  999 CONTINUE
      RETURN
      END
