      SUBROUTINE UGINIT
*.
*...UGINIT   Initialization routine
*.
*. SEQUENCE  : GCLIST GCRZ
*.           : LPFLAG NTUPLE RCREP  XECGEO XECINT XECSCI AIST
*. CALLS     : FFINIT FFKEY  FFSET  GDINIT GFFGO  GINIT  GMATE
*.           : GPART  GPHYSI GZINIT
*.           : LPGEOM
*.           : HBNAME HBNT   HBSET  HROPEN IGMETA
*.           : USIFFR USINIT VBLANK XSINIT
*.           : AISTCG UHTOC HRGET FUNLXP
*. CALLED    : MAIN
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.06
*. CREATED   : 06-May-00
*. LAST MOD  : 15-Jul-02
*.
*. Modification Log.
*. 23-Jan-03   R.Sawada        (V1.07) Added Xdepos(5) and Xdepo(5)
*. 15-Jul-02   K.Ozone         (V1.06) Added ZIN.
*. 06-Jul-02   K.Ozone         (V1.05) Change blocks of ntuples.
*.                             Added and detailed REPORTs for distribution
*.                             of x,y,z, theta,phi, and momentum.
*.                             Add checks for histograms' exisitance.
*.                             Change usage of PKINE and adapt MOMTM.
*.                             Discard BSC* to use unified array DST*.
*. 31-Mar-02   K.Ozone         (V1.04) Added a call for BSC hist creation
*. 20-Mar-02   K.Ozone         (V1.03) Added RZ file load for BSC
*. 08-Mar-02   K.Ozone         (V1.02) Adapted BSCON switch
*. 02-Aug-01   K.Ozone         (V1.01) Support for Comptom edge
*.                             distributions
*. 06-May-00   T.Mashimo       (V1.00) First version.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "geant321/gclist.inc"
#include "geant321/gcrz.inc"
#include "geant321/gckine.inc"
#include "lpflag.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "rcrep.inc"
#include "cmpedg.inc"
*
      REAL    FFSPAC
      COMMON /CFREAD/ FFSPAC(15000)
*
      INTEGER IQUEST, IERR
      COMMON /QUEST/ IQUEST(100)
*
      CHARACTER*80  CPSNAM, CHBNAM
      CHARACTER*80  CHNAM
      CHARACTER*4   CMXPMT, CMXDEP
      CHARACTER*500 CHFORM
*
      CHARACTER*4 CUNIT
      CHARACTER*8 CDSTNAM
*
      INTEGER I
      INTEGER NPMT
*
      EXTERNAL CMPEDG
*
*-- Initialize GEANT
*
      CALL GINIT
*
*--   Reinitialize FFREAD with more space/ 12 character names
*
      CALL FFINIT(15000)
      CALL FFSET('SIZE', 12)
*
*-- Define LP's FFREAD data cards
*
      CALL LPIFFR
*
      CALL GFFGO
*
*-- Initialize data structure
*
      CALL GZINIT
*
*-- Initialize graphics
*
      CALL UHTOC(LPSNAM, 4, CPSNAM, NAMLEN)
      IF (CPSNAM .NE. ' ') THEN
         OPEN(LUNPS, FILE=CPSNAM,
     +               STATUS='UNKNOWN', FORM='FORMATTED')
         CALL IGMETA(-LUNPS, -111)
      END IF
*
      CALL GDINIT
*
*-- Particle table initialization
*
      CALL GPART
*
*-- Define standard materials
*
      CALL GMATE
*
*-- Geometry and materials description
*
      CALL LPGEOM
*
*-- Energy loss and cross-sections tables
*
      CALL GPHYSI
*
*-- Print banks
*
      CALL GPRINT('MATE', 0)
      CALL GPRINT('TMED', 0)
      CALL GPRINT('VOLU', 0)
*
*-- Open an output HBOOK file
*
      CALL UHTOC(LHBNAM, 4, CHBNAM, NAMLEN)
      IF (CHBNAM .NE. ' ') THEN
         CALL HBSET('BSIZE', NRECNT, IERR)
         IQUEST(10) = MXRCNT
         CALL HROPEN(LUNHBK, 'HISTO', CHBNAM, 'NQ', NRECNT, IERR)
         IF (NTUPON .EQ. 1) THEN
            CALL HBNT(IDNTPL, TITLNT, ' ')
            WRITE(CMXDEP, '(I4)') MXDEPO
            CHFORM = 'EVENT:I'
            CALL HBNAME(IDNTPL, BLKEVT, EVENT, CHFORM)
            CHFORM = 'EIN,XIN,YIN,ZIN,THIN,PHIN'
            CALL HBNAME(IDNTPL, BLKBEM, EIN, CHFORM)
            IF(TIMEOUT .EQ. 1) THEN
               CHFORM = 'DEXE,DEPMT,XCONV(3),XINTR(3),XDEPO(5)'
            ELSE
               CHFORM = 'DEXE,DEPMT,XCONV(3),XINTR(3),XDEPO(4)'
            ENDIF
            CALL HBNAME(IDNTPL, BLKITR, DEXE, CHFORM)
            IF (SUMOUT .NE. 0) THEN
               CHFORM = 'NTOTPE:I,NSUM:I,NPEW(6):I'
               CALL HBNAME(IDNTPL, BLKSUM, NTOTPE, CHFORM)
            END IF
            NPMT=2*(NXPMT*NYPMT+NYPMT*NZPMT+NZPMT*NXPMT)
            IF (NPEOUT .NE. 0) THEN
               IF (NPMT .LT. 10) THEN
                  WRITE(CMXPMT, '(I1)') NPMT
               ELSE IF (NPMT .LT. 100) THEN
                  WRITE(CMXPMT, '(I2)') NPMT
               ELSE IF (NPMT .LT. 1000) THEN
                  WRITE(CMXPMT, '(I3)') NPMT
               ELSE
                  CMXPMT='0' ! to be error
               END IF
               CHFORM = 'NPE('//CMXPMT//'):I'
               CALL HBNAME(IDNTPL, BLKLPM, NPE, CHFORM)
            END IF
            IF ((EXPOUT .NE. 0) .AND. (NPMT .EQ. 264)) THEN
               CHFORM = 'CADC(228),QSUM'
               CALL HBNAME(IDNTPL, BLKLPE, CADC, CHFORM)
               CHFORM = 'Q_RIGHT,Q_LEFT,Q_BOTTOM,Q_TOP,Q_FRONT,Q_BACK'
               CALL HBNAME(IDNTPL, BLKLPE, Q_RIGHT, CHFORM)
            END IF
            IF (DEPOUT .NE. 0) THEN
               IF (TIMEOUT .EQ. 1) THEN
                  CHFORM = 'NDEPO[0,'//CMXDEP//'],XDEPOS(5,NDEPO)'
               ELSE               
                  CHFORM = 'NDEPO[0,'//CMXDEP//'],XDEPOS(4,NDEPO)'
               ENDIF
               CALL HBNAME(IDNTPL, BLKDEP, NDEPO, CHFORM)
            END IF
         END IF
      ELSE
         NTUPON = 0
      END IF
*
*-- Print parameters for the run
*
      IF (NTUPON .EQ. 0) THEN
         WRITE(CHREP, '(''Ntuple creation: OFF'')' )
      ELSE
         WRITE(CHREP, '(''Ntuple creation: ON'')' )
      END IF
      CALL REPORT('UGINIT', 1, 'INFO')
*
      IF (NPLOT .LE. 0) THEN
         WRITE(CHREP, '(''Event plotting: OFF'')' )
         CALL REPORT('UGINIT', 2, 'INFO')
      ELSE
         WRITE(CHREP,
     +        '(''Event plotting: ON for events '', I8, ''-'', I8)' )
     +         LPLOT(1), LPLOT(2)
         CALL REPORT('UGINIT', 2, 'INFO')
         WRITE(CHREP,
     +        '(''P cut for GSXYZ in GUSTEP: '', F10.3, '' MeV'')')
     +         CUTXYZ
         CALL REPORT('UGINIT', 3, 'INFO')
      END IF
*
      CALL XEGPAR
*
*-- Initialize XS (Xe scintillation photon tracking)
*
      CALL XSINIT
*
*-- Event number in /NTUPLE/
*
      EVENT = 0

*
*-- Read/Create a user-defined beam properties (x,y,z,theta,phi)
*      0:flat, 1:given histogram, 2: Gaussian,
*
      DO I=1,5
         IF (I .EQ. 1) THEN
            CALL UHTOC(XHNAM, 4, CHNAM, NAMLEN)
            CDSTNAM='X'
            CUNIT='cm '
         ELSE IF (I .EQ. 2) THEN
            CALL UHTOC(YHNAM, 4, CHNAM, NAMLEN)
            CDSTNAM='Y'
            CUNIT='cm '
         ELSE IF (I .EQ. 3) THEN
            CALL UHTOC(ZHNAM, 4, CHNAM, NAMLEN)
            CDSTNAM='Z'
            CUNIT='cm '
         ELSE IF (I .EQ. 4) THEN
            CALL UHTOC(THNAM, 4, CHNAM, NAMLEN)
            CDSTNAM='theta'
            CUNIT='deg'
         ELSE
            CALL UHTOC(PHNAM, 4, CHNAM, NAMLEN)
            CDSTNAM='phi'
            CUNIT='deg'
         END IF
         WRITE(CHREP,
     +              '(''Distribution of '', A)' ) CDSTNAM
               CALL REPORT('UGINIT', 4, 'INFO')
         IF (DSTSW(I) .NE. 0) THEN
            OPEN (2, FILE=CHNAM, IOSTAT=IERR)
            IF (IERR .NE. 0) THEN
               WRITE(CHREP,
     +              '(''No such a file: '', A)' ) CHNAM
               CALL REPORT('UGINIT', 4, 'ERROR')
               WRITE(CHREP,
     +              '(''Instead, adapted flat distribution.'')' )
               CALL REPORT('UGINIT', 4, 'ERROR')
               WRITE(CHREP,
     +           '(F8.2, '' - '', F8.2, A)' )
     +           PKINE(I*2-1), PKINE(I*2), CUNIT
            CALL REPORT('UGINIT', 4, 'INFO')
               DSTSW(I) = 0
            ELSE
               CLOSE(2)
               WRITE(CHREP,
     +              '(''Histogram: '', A)' ) CHNAM
               CALL REPORT('UGINIT', 4, 'INFO')
               CALL HRGET(DSTHID(6), CHNAM, ' ')
            END IF
         ELSE IF (DSTSW(I) .EQ. 2) THEN
            WRITE(CHREP,
     +           '(''Gaussian; mean = '', F8.2, A)' )
     +           PKINE(I*2-1), CUNIT
            CALL REPORT('UGINIT', 4, 'INFO')
            WRITE(CHREP,
     +           '(''Gaussian; sigma = '', F8.2, A)' )
     +           PKINE(I*2),CUNIT
            CALL REPORT('UGINIT', 4, 'INFO')
         ELSE
            WRITE(CHREP,
     +           '(''Flat: '', F8.2, '' - '', F8.2, A)')
     +           PKINE(I*2-1), PKINE(I*2), CUNIT
            CALL REPORT('UGINIT', 4, 'INFO')
         END IF
      END DO


*
*-- Read/Create a user-defined beam momentum distribution
*      0:flat, 1:given histogram, 2: Gaussian,
*      3:TERAS spectrum generated by built-in generator
*      4:back scat. Compton edge(pol2 approx. function)
*
      IF (DSTSW(6) .EQ. 1) THEN
         CALL UHTOC(MHNAM, 4, CHNAM, NAMLEN)
         OPEN (2, FILE=CHNAM, IOSTAT=IERR)
         IF (IERR .NE. 0) THEN
            WRITE(CHREP,
     +           '(''No such a file: '', A)' ) CHNAM
            CALL REPORT('UGINIT', 5, 'ERROR')
            WRITE(CHREP,
     +           '(''Instead, adapt flat momentum dist.'')' )
            CALL REPORT('UGINIT', 5, 'ERROR')
            DSTSW(6) = 0
         ELSE
            CLOSE(2)
            WRITE(CHREP,
     +           '(''Momentum obeys histogram: '', A)' ) CHNAM
            CALL REPORT('UGINIT', 5, 'INFO')
            CALL HRGET(DSTHID(6), CHNAM, ' ')
         END IF
      ELSE IF (DSTSW(6) .EQ. 2) THEN
         WRITE(CHREP,
     +        '(''Gaussian; mean = '', F8.2, '' MeV'')')
     +        MOMTM(1)
         CALL REPORT('UGINIT', 5, 'INFO')
         WRITE(CHREP,
     +        '(''Gaussian; sigma = '', F8.2, '' MeV'')')
     +        MOMTM(2)
         CALL REPORT('UGINIT', 5, 'INFO')
      ELSE IF (DSTSW(6) .EQ. 3) THEN
         DSTHID(6) = 12345
         CALL AISTCG
         WRITE(CHREP,
     +        '(''Created AIST momentum distribution.'')')
         CALL REPORT('UGINIT', 5, 'INFO')
      ELSE IF (DSTSW(6) .EQ. 4) THEN
         WRITE(CHREP,
     +        '(''Compton-edge-like Momentum (obsolete): '')')
     +        MOMTM(1), MOMTM(2)
         CALL REPORT('UGINIT', 5, 'INFO')
         WRITE(CHREP,
     +        '(F8.2, '' - '', F8.2, '' MeV'')')
     +        MOMTM(1), MOMTM(2)
         CALL REPORT('UGINIT', 5, 'INFO')
         CALL FUNLXP(CMPEDG, FSPACE, MOMTM(1), MOMTM(2))
      ELSE
         WRITE(CHREP,
     +        '(''Flat momentum: '', F8.2, '' - '', F8.2, '' MeV'')')
     +        MOMTM(1), MOMTM(2)
         CALL REPORT('UGINIT', 5, 'INFO')
      END IF
*
*-- Call user initialization routine
*
      CALL USINIT
*
  999 CONTINUE
      RETURN
      END
