      SUBROUTINE XEPLEV
*.
*...XEPLEV   Print the plot of deposit energies for this event
*.
*. SEQUENCE  : GCFLAG GCLIST RCREP  XECGEO XECINT XECSCI
*. CALLS     : HBOOK1 HBOOK2 HF1    HF2
*. CALLED    : GUOUT
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.00
*. CREATED   : 05-Apr-00
*. LAST MOD  : 05-Apr-00
*.
*. Modification Log.
*. 05-Apr-00   T.Mashimo       (V1.00) 1st version based on T. Mori's
*.                             PLOTEV.
*.
*.**********************************************************************
#include "declare.inc"
#include "geant321/gcflag.inc"
#include "geant321/gclist.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "xecsci.inc"
#include "rcrep.inc"
*
      INTEGER NX, NY
      INTEGER I, K, L, IW
      REAL    X0, Y0
      INTEGER INIT / 0 /
      SAVE    INIT
*
*-- Define histograms at first call
*
      IF (INIT .EQ. 0) THEN
         INIT = 1
         IF (NPLOT .GT. 0) THEN
            CALL HCDIR('//PAWC', ' ')
            CALL HMDIR('XEPLEV', 'S')
            NX = NXPMT + 2*NZPMT + 2
            NY = 2*(NYPMT+NZPMT) + 2
            DO 100 I = LPLOT(1), LPLOT(2)
               CALL HBOOK2(2000+I, 'mini Kamiokande',
     +            NX+2, -1., FLOAT(NX+1), NY+2, -1., FLOAT(NY+1), 0.)
*
               CALL HBOOK1(3000+I, 'E depo  vs  X',
     +                     100, WALL(1), WALL(2), 0.)
               CALL HBOOK1(4000+I, 'E depo  vs  Y',
     +                     100, WALL(3), WALL(4), 0.)
               CALL HBOOK1(5000+I, 'E depo  vs  Z',
     +                     100, WALL(5), WALL(6), 0.)
  100       CONTINUE
            CALL HCDIR('//PAWC', ' ')
         END IF
      END IF
*
*
*
      IF (NPLOT .LE. 0. .OR.
     +    IEVENT .LT. LPLOT(1) .OR. IEVENT .GT. LPLOT(2)) GOTO 999
         CALL HCDIR('//PAWC/XEPLEV', ' ')
*
*--
*-- "Kamiokande" plots
*--
*
*-- -X wall
*
      IW = 1
      X0 = FLOAT(NZPMT) - 0.5
      Y0 = FLOAT(NYPMT+NZPMT) + 0.5
      DO 210 K = 1, NIJPMT(1,IW)
      DO 210 L = 1, NIJPMT(2,IW)
         I = K + (L-1)*IJOFFS(IW) + IWOFFS(IW)
         CALL HF2(2000+IEVENT, X0-FLOAT(L-1), Y0+FLOAT(K-1),
     +                         FLOAT(NPEPMT(I)))
 210  CONTINUE
*
*-- +X wall
*
      IW = 2
      X0 = FLOAT(NZPMT+NXPMT) + 0.5
      Y0 = FLOAT(NYPMT+NZPMT) + 0.5
      DO 220 K = 1, NIJPMT(1,IW)
      DO 220 L = 1, NIJPMT(2,IW)
         I = K + (L-1)*IJOFFS(IW) + IWOFFS(IW)
         CALL HF2(2000+IEVENT, X0+FLOAT(L-1), Y0+FLOAT(K-1),
     +                         FLOAT(NPEPMT(I)))
 220  CONTINUE
*
*-- -Y wall
*
      IW = 3
      X0 = FLOAT(NZPMT) + 0.5
      Y0 = FLOAT(NYPMT+NZPMT) - 0.5
      DO 310 K = 1, NIJPMT(1,IW)
      DO 310 L = 1, NIJPMT(2,IW)
         I = K + (L-1)*IJOFFS(IW) + IWOFFS(IW)
         CALL HF2(2000+IEVENT, X0+FLOAT(L-1), Y0-FLOAT(K-1),
     +                         FLOAT(NPEPMT(I)))
 310  CONTINUE
*
*-- +Y wall
*
      IW = 4
      X0 = FLOAT(NZPMT) + 0.5
      Y0 = FLOAT(NYPMT+NZPMT+NYPMT) + 0.5
      DO 320 K = 1, NIJPMT(1,IW)
      DO 320 L = 1, NIJPMT(2,IW)
         I = K + (L-1)*IJOFFS(IW) + IWOFFS(IW)
         CALL HF2(2000+IEVENT, X0+FLOAT(L-1), Y0+FLOAT(K-1),
     +                         FLOAT(NPEPMT(I)))
 320  CONTINUE
*
*-- -Z wall
*
      IW = 5
      X0 = FLOAT(NZPMT) + 0.5
      Y0 = FLOAT(NYPMT+NZPMT) + 0.5
      DO 410 K = 1, NIJPMT(1,IW)
      DO 410 L = 1, NIJPMT(2,IW)
         I = K + (L-1)*IJOFFS(IW) + IWOFFS(IW)
         CALL HF2(2000+IEVENT, X0+FLOAT(K-1), Y0+FLOAT(L-1),
     +                         FLOAT(NPEPMT(I)))
 410  CONTINUE
*
*-- +Z wall
*
      IW = 6
      X0 = FLOAT(NZPMT) + 0.5
      Y0 = FLOAT(NYPMT) - 0.5
      DO 420 K = 1, NIJPMT(1,IW)
      DO 420 L = 1, NIJPMT(2,IW)
         I = K + (L-1)*IJOFFS(IW) + IWOFFS(IW)
         CALL HF2(2000+IEVENT, X0+FLOAT(K-1), Y0-FLOAT(L-1),
     +                         FLOAT(NPEPMT(I)))
 420  CONTINUE
*
*-- Spatial distribution of deposited energy
*
      DO 500 I = 1, NDEXE
         CALL HF1(3000+IEVENT, XDEXE(1,I), XDEXE(4,I))
         CALL HF1(4000+IEVENT, XDEXE(2,I), XDEXE(4,I))
         CALL HF1(5000+IEVENT, XDEXE(3,I), XDEXE(4,I))
 500  CONTINUE
*
      CALL HCDIR('//PAWC', ' ')
*
  999 RETURN
      END
