      SUBROUTINE XNDBIN(X, Y, H0, I)
*.
*...XNDBIN   Draw a rectangle (histogram bar)
*.
*. SEQUENCE  : NTUPLE RCREP  XNCGEO XNCPMT XNCINT XNCTRL XNGCOM
*. CALLS     : IPL    ISPLCI
*. CALLED    : XNDXYZ
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.00
*. CREATED   : 12-Mar-99
*. LAST MOD  : 18-May-00
*.
*. Modification Log.
*. 18-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's xedbin.F.  RPMT -> 2.*RCATH.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xecgeo.inc"
#include "xecpmt.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "xnctrl.inc"
#include "xngcom.inc"
#include "gksenum.inc"
#include "rcrep.inc"
*
      INTEGER I
      REAL    X, Y, H0
*
      REAL    H10K
      PARAMETER (H10K = 40.)  ! histogram height (cm) for 10k p.e.'s
      REAL    H, PX(5), PY(5), X1, X2, Y1, Y2, W
*
      IF (H0 .LE. 0.) GOTO 999
*
      W = 2.*RCATH   ! bar width
*
      H = ALOG10(H0) 
      IF      (H .GE. 4.) THEN
         CALL ISPLCI(2) ! red
      ELSE IF (H .GE. 3.) THEN
         CALL ISPLCI(5) ! yellow
      ELSE IF (H .GE. 2.) THEN
         CALL ISPLCI(3) ! green
      ELSE IF (H .GE. 1.) THEN
         CALL ISPLCI(7) ! light blue
      ELSE
         CALL ISPLCI(1)
      END IF
      IF (JLOGP .EQ. 1) THEN
         H = H/4.*H10K
      ELSE
         H = H0/10000.*H10K
      END IF
*
      IF (I .EQ. 1) THEN       ! up 
         X1 = X - W/2.
         X2 = X + W/2.
         Y1 = Y
         Y2 = Y + H
      ELSE IF (I .EQ. 2) THEN  ! down
         X1 = X - W/2.
         X2 = X + W/2.
         Y1 = Y
         Y2 = Y - H
      ELSE IF (I .EQ. 3) THEN  ! right
         X1 = X
         X2 = X + H
         Y1 = Y - W/2.
         Y2 = Y + W/2.
      ELSE IF (I .EQ. 4) THEN  ! left
         X1 = X
         X2 = X - H
         Y1 = Y - W/2.
         Y2 = Y + W/2.
      END IF
*
      PX(1) = X1
      PY(1) = Y1
      PX(2) = X2
      PY(2) = Y1
      PX(3) = X2
      PY(3) = Y2
      PX(4) = X1
      PY(4) = Y2
      PX(5) = PX(1)
      PY(5) = PY(1)
      CALL IPL(5, PX, PY)
*
  999 CONTINUE
      RETURN
      END
