      SUBROUTINE XNDCIR(XC, YC, R)
*.
*...XNDCIR   Draw a circle for Kamiokande-like unfolded plot
*.
*. SEQUENCE  : XNGCOM
*. CALLS     : IGARC  ISPLCI
*. CALLED    : XNDKAM
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.00
*. CREATED   : 12-Mar-99
*. LAST MOD  : 18-May-00
*.
*. Modification Log.
*. 18-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's xedcir.F.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xngcom.inc"
*
      REAL XC, YC, R
*
      REAL R10K
      PARAMETER (R10K = 3.)  ! radius (cm) for 10k photoelectrons
      REAL RC
*
      RC = ALOG10(R) 
      IF (RC .GE. 4.) THEN
         CALL ISPLCI(2) ! red
      ELSE IF (RC .GE. 3.) THEN
         CALL ISPLCI(5) ! yellow
      ELSE IF (RC .GE. 2.) THEN
         CALL ISPLCI(3) ! green
      ELSE IF (RC .GE. 1.) THEN
         CALL ISPLCI(7) ! light blue
      ELSE
         CALL ISPLCI(1)
      END IF
      IF (JLOGP .EQ. 1) THEN
         RC = RC/4.*R10K        ! radius = log(Npe)
      ELSE
         RC = SQRT(R)/100.*R10K ! radius = sqrt(Npe)
      END IF
      IF (RC .GT. 0.) CALL IGARC(XC, YC, RC, RC, 0., 0.)
*
      RETURN
      END
