      SUBROUTINE XNDEDE(IX)
*.
*...XNDEDE   Plot energy deposits in XYZ views; area of circle = energy
*.
*. SEQUENCE  : NTUPLE RCREP  XNCGEO XNCINT XNCTRL XNGCOM
*. CALLS     : IGARC  ISLN   ISPLCI
*. CALLED    : XNDMC
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.01
*. CREATED   : 12-Mar-99
*. LAST MOD  : 03-Jul-02
*.
*. Modification Log.
*. 03-Jul-02   K.Ozone         (V1.01) Change XDEPO to XDEPOS
*. 15-Jan-01   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's xedede.F.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "xnctrl.inc"
#include "xngcom.inc"
#include "gksenum.inc"
#include "rcrep.inc"
*
      INTEGER IX
*
      REAL    R1MEV, EMINPL
      PARAMETER (R1MEV  = 0.5)  ! radius (cm) for 1 MeV energy deposit
      PARAMETER (EMINPL = 0.0)  ! minimum energy (MeV) to plot
      INTEGER I
      REAL    EMEV, RC
*
      CALL ISLN(GLSOLI)
      DO 100 I = 1, NDEPO
         EMEV = XDEPOS(4,I)*1000.  ! XDEPOS(4) in GeV
         IF (EMEV .LT. EMINPL) GO TO 100
         IF      (EMEV .GE. 5.) THEN
            CALL ISPLCI(2)          ! > 5MeV red
         ELSE IF (EMEV .GE. 1.) THEN
            CALL ISPLCI(5)          ! > 1MeV yellow
         ELSE IF (EMEV .GE. 0.5) THEN
            CALL ISPLCI(3)          ! > 0.5 MeV green
         ELSE IF (EMEV .GE. 0.1) THEN
            CALL ISPLCI(7)          ! > 0.1 MeV light blue
         ELSE
            CALL ISPLCI(1)
         END IF
         IF (JLOGP .EQ. 1) THEN
            RC = ALOG10(EMEV*1000.)/3.*R1MEV
         ELSE
            RC = SQRT(EMEV)*R1MEV
         END IF
         IF (RC .LE. 0.) GO TO 100
         IF (IX .EQ. 1) THEN
            CALL IGARC(XDEPOS(2,I), XDEPOS(3,I), RC, RC, 0., 0.) ! yz plot
         ELSE IF (IX .EQ. 2) THEN
            CALL IGARC(XDEPOS(1,I), XDEPOS(3,I), RC, RC, 0., 0.) ! xz plot
         ELSE IF (IX .EQ. 3) THEN
            CALL IGARC(XDEPOS(1,I), XDEPOS(2,I), RC, RC, 0., 0.) ! xy plot
         END IF
  100 CONTINUE
*
      RETURN
      END
