      SUBROUTINE XNDMC
*.
*...XNDMC    Draw MC cheat information
*.
*. SEQUENCE  : NTUPLE RCREP  XNCGEO XNCINT XNCTRL XNGCOM
*. CALLS     : IPL    IPM    ISELNT ISLN   ISMK   ISPLCI ISPMCI
*.           : XNDEDE
*. CALLED    : XNDRAW
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.01
*. CREATED   : 12-Mar-99
*. LAST MOD  : 03-Jul-02
*.
*. Modification Log.
*. 03-Jul-02   K.Ozone         (V1.01) Change ZFIRST to XINTR(3)
*. 18-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's xedmc.F.
*.                             XXENON/YXENON/ZXENON -> PMTINT*NXPMT,etc.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "xnctrl.inc"
#include "xngcom.inc"
#include  "gksenum.inc"
#include "rcrep.inc"
*
      REAL X(6), Y(6)
*
*-- For Kamiokande plot
*
      IF (ITYPE .EQ. 2) THEN
*
         CALL ISELNT(JTNR4)
*
         X(1) =  XIN
         X(2) =  XIN
         X(3) =  XIN
         X(4) = -XINTR(3) - PMTINT*FLOAT(NXPMT)/2.
         X(5) = +XINTR(3) + PMTINT*FLOAT(NXPMT)/2.
         X(6) = -XIN + PMTINT*FLOAT(NXPMT) + PMTINT*FLOAT(NZPMT)
         Y(1) =  YIN
         Y(2) = -XINTR(3) - PMTINT*FLOAT(NYPMT)/2.
         Y(3) = +XINTR(3) + PMTINT*FLOAT(NYPMT)/2.
         Y(4) = +YIN
         Y(5) = +YIN
         Y(6) = +YIN
         CALL ISMK(5)    ! x mark
         CALL ISPMCI(2)  ! red
         CALL IPM(6, X, Y)
*
*-- For XYZ views
*
      ELSE IF (ITYPE .EQ. 1) THEN
*
*-- First plot (YZ)
*
         CALL ISELNT(JTNR1)
*
*-- incident gamma ray
*
         X(1) = YIN - 50.*TAN(THIN*0.01745)
         Y(1) = -50. 
         X(2) = YIN + XINTR(3)*TAN(THIN*0.01745)
         Y(2) = XINTR(3)
         CALL ISPLCI(5)  ! yellow
         CALL ISLN(GLDASH)
         CALL IPL(2, X, Y)
*
*-- Energy deposit
*
         CALL XNDEDE(1)
*
*-- Second plot (XZ)
*
         CALL ISELNT(JTNR2)
*
*-- Incident gamma ray
*
         X(1) = XIN
         Y(1) = -50. 
         X(2) = XIN
         Y(2) = XINTR(3)
         CALL ISPLCI(5)  ! yellow
         CALL ISLN(GLDASH)
         CALL IPL(2, X, Y)
*
*-- Energy deposit
*
         CALL XNDEDE(2)
*
*-- Third plot (XY)
*
         CALL ISELNT(JTNR3)
*
*-- Incident gamma ray
*
         X(1) = XIN
         Y(1) = YIN
         CALL ISMK(5)    ! x mark
         CALL ISPMCI(2)  ! red
         CALL IPM(1, X, Y)
*
*-- Energy deposit
*
         CALL XNDEDE(3)
*
      END IF
*
      RETURN
      END
