      SUBROUTINE XNDPMT
*.
*...XNDPMT   Draw Kamiokande-like unfolded plot with PMTs
*.
*. SEQUENCE  : NTUPLE RCREP  XNCGEO XNCPMT XNCINT XNCTRL XNGCOM
*. CALLS     : IGARC  IPL    ISELNT ISLN   ISPLCI
*. CALLED    : XNDRAW
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.00
*. CREATED   : 12-Mar-99
*. LAST MOD  : 18-May-00
*.
*. Modification Log.
*. 18-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's xedpmt.F.  RPMT -> 2.*RCATH.
*.                             XXENON/YXENON/ZXENON -> PMTINT*NXPMT,etc.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xecgeo.inc"
#include "xecpmt.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "xnctrl.inc"
#include "xngcom.inc"
#include "gksenum.inc"
#include "rcrep.inc"
*
      INTEGER IW, I, J, K
      REAL    X0(2), PX(5), PY(5), XC, YC, RC
*
*-- PMT radius to draw
*
      RC = RCATH
*
*-- select forth view
*
      CALL ISELNT(JTNR4)
*
*-- front face (-Z wall): (+X,+Y) view
*
      X0(1) = 0.  ! origin
      X0(2) = 0.  !
      PX(1) = WALL(1) + X0(1)  ! -x wall
      PY(1) = WALL(3) + X0(2)  ! -y wall
      PX(2) = WALL(2) + X0(1)
      PY(2) = WALL(3) + X0(2)
      PX(3) = WALL(2) + X0(1)
      PY(3) = WALL(4) + X0(2)
      PX(4) = WALL(1) + X0(1)
      PY(4) = WALL(4) + X0(2)
      PX(5) = PX(1)
      PY(5) = PY(1)
      CALL ISPLCI(1)
      CALL ISLN(GLSOLI)
      CALL IPL(5, PX, PY)    ! draw box
      IW = 5      ! -Z wall
      DO I = 1, NIJPMT(1,IW)
      DO J = 1, NIJPMT(2,IW)
         K = I + (J-1)*IJOFFS(IW) + IWOFFS(IW)  ! PMT address
         XC = PMTPOS(1,K) + X0(1)     ! +X,+Y
         YC = PMTPOS(2,K) + X0(2)     ! 
         CALL IGARC(XC, YC, RC, RC, 0., 0.)
      END DO
      END DO
*
*-- rear face (+Z wall): (-X,+Y) view
*
      X0(1) = PMTINT*FLOAT(NXPMT) + PMTINT*FLOAT(NZPMT)  ! origin
      X0(2) = 0.             !
      PX(1) = WALL(1) + X0(1)  ! -x wall
      PY(1) = WALL(3) + X0(2)  ! -y wall
      PX(2) = WALL(2) + X0(1)
      PY(2) = WALL(3) + X0(2)
      PX(3) = WALL(2) + X0(1)
      PY(3) = WALL(4) + X0(2)
      PX(4) = WALL(1) + X0(1)
      PY(4) = WALL(4) + X0(2)
      PX(5) = PX(1)
      PY(5) = PY(1)
      CALL ISPLCI(1)
      CALL ISLN(GLSOLI)
      CALL IPL(5, PX, PY)    ! draw box
      IW = 6      ! +Z wall
      DO I = 1, NIJPMT(1,IW)
      DO J = 1, NIJPMT(2,IW)
         K = I + (J-1)*IJOFFS(IW) + IWOFFS(IW)  ! PMT address
         XC = -PMTPOS(1,K) + X0(1)  ! -X,+Y
         YC =  PMTPOS(2,K) + X0(2)  !
         CALL IGARC(XC, YC, RC, RC, 0., 0.)
      END DO
      END DO
*
*-- side 1 (-X wall): (-Z,+Y) view
*
      X0(1) = -PMTINT*FLOAT(NXPMT)/2.     ! origin
      X0(2) = 0.             !
      PX(1) = -WALL(5) + X0(1)  ! -z wall
      PY(1) =  WALL(3) + X0(2)  ! -y wall
      PX(2) = -WALL(6) + X0(1)
      PY(2) =  WALL(3) + X0(2)
      PX(3) = -WALL(6) + X0(1)
      PY(3) =  WALL(4) + X0(2)
      PX(4) = -WALL(5) + X0(1)
      PY(4) =  WALL(4) + X0(2)
      PX(5) = PX(1)
      PY(5) = PY(1)
      CALL ISPLCI(1)
      CALL ISLN(GLSOLI)
      CALL IPL(5, PX, PY)    ! draw box
      IW = 1      ! -X wall
      DO I = 1, NIJPMT(1,IW)
      DO J = 1, NIJPMT(2,IW)
         K = I + (J-1)*IJOFFS(IW) + IWOFFS(IW)  ! PMT address
         XC = -PMTPOS(3,K) + X0(1)  ! -Z,+Y
         YC =  PMTPOS(2,K) + X0(2)  !
         CALL IGARC(XC, YC, RC, RC, 0., 0.)
      END DO
      END DO
*
*-- side 2 (+X wall): (+Z,+Y) view
*
      X0(1) =  PMTINT*FLOAT(NXPMT)/2.     ! origin
      X0(2) = 0.             !
      PX(1) = WALL(5) + X0(1)  ! -z wall
      PY(1) = WALL(3) + X0(2)  ! -y wall
      PX(2) = WALL(6) + X0(1)
      PY(2) = WALL(3) + X0(2)
      PX(3) = WALL(6) + X0(1)
      PY(3) = WALL(4) + X0(2)
      PX(4) = WALL(5) + X0(1)
      PY(4) = WALL(4) + X0(2)
      PX(5) = PX(1)
      PY(5) = PY(1)
      CALL ISPLCI(1)
      CALL ISLN(GLSOLI)
      CALL IPL(5, PX, PY)    ! draw box
      IW = 2      ! +X wall
      DO I = 1, NIJPMT(1,IW)
      DO J = 1, NIJPMT(2,IW)
         K = I + (J-1)*IJOFFS(IW) + IWOFFS(IW)  ! PMT address
         XC =  PMTPOS(3,K) + X0(1)  ! +Z,+Y
         YC =  PMTPOS(2,K) + X0(2)  !
         CALL IGARC(XC, YC, RC, RC, 0., 0.)
      END DO
      END DO
*
*-- side 3 (-Y wall): (+X,-Z) view
*
      X0(1) = 0.              ! origin
      X0(2) = -PMTINT*FLOAT(NYPMT)/2.
      PX(1) =  WALL(1) + X0(1)  ! -x wall
      PX(2) =  WALL(2) + X0(1)
      PX(3) =  WALL(2) + X0(1)
      PX(4) =  WALL(1) + X0(1)
      PY(1) = -WALL(5) + X0(2)  ! -z wall
      PY(2) = -WALL(5) + X0(2)
      PY(3) = -WALL(6) + X0(2)
      PY(4) = -WALL(6) + X0(2)
      PX(5) = PX(1)
      PY(5) = PY(1)
      CALL ISPLCI(1)
      CALL ISLN(GLSOLI)
      CALL IPL(5, PX, PY)    ! draw box
      IW = 3      ! -Y wall
      DO I = 1, NIJPMT(1,IW)
      DO J = 1, NIJPMT(2,IW)
         K = I + (J-1)*IJOFFS(IW) + IWOFFS(IW)  ! PMT address
         XC =  PMTPOS(1,K) + X0(1)  ! +X,-Z
         YC = -PMTPOS(3,K) + X0(2)  !
         CALL IGARC(XC, YC, RC, RC, 0., 0.)
      END DO
      END DO
*
*-- side 4 (+Y wall): (+X,+Z) view
*
      X0(1) = 0.              ! origin
      X0(2) =  PMTINT*FLOAT(NYPMT)/2.
      PX(1) =  WALL(1) + X0(1)  ! -x wall
      PX(2) =  WALL(2) + X0(1)
      PX(3) =  WALL(2) + X0(1)
      PX(4) =  WALL(1) + X0(1)
      PY(1) =  WALL(5) + X0(2)  ! -z wall
      PY(2) =  WALL(5) + X0(2)
      PY(3) =  WALL(6) + X0(2)
      PY(4) =  WALL(6) + X0(2)
      PX(5) = PX(1)
      PY(5) = PY(1)
      CALL ISPLCI(1)
      CALL ISLN(GLSOLI)
      CALL IPL(5, PX, PY)    ! draw box
      IW = 4      ! +Y wall
      DO I = 1, NIJPMT(1,IW)
      DO J = 1, NIJPMT(2,IW)
         K = I + (J-1)*IJOFFS(IW) + IWOFFS(IW)  ! PMT address
         XC = PMTPOS(1,K) + X0(1)  ! +X,+Z
         YC = PMTPOS(3,K) + X0(2)  !
         CALL IGARC(XC, YC, RC, RC, 0., 0.)
      END DO
      END DO
*
      RETURN
      END
