      SUBROUTINE XNDRAW
*.
*...XNDRAW   Draw an event
*.
*. SEQUENCE  : NTUPLE RCREP  XNCGEO XNCINT XNCTRL XNGCOM
*. CALLS     : ICLRWK IGMENU ISCHH  ISCHUP ISELNT ISPLCI
*.           : ISTXAL ISTXCI ISTXFP ITX
*.           : XNDKAM XNDKMC XNDMC  XNDPMT XNDXYZ XNHEAD
*.           : XNPSBG XNPSOF XNPSON XNPWGT XNTRI  XNUNZO XNZOOM
*. CALLED    : XNIKU  XNNEXT
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.00
*. CREATED   : 12-Mar-99
*. LAST MOD  : 18-May-00
*.
*. Modification Log.
*. 18-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's xedraw.F.  NEVT -> IEVENT.
*. 19-Jul-99   T.Mori          EOF/BOF messages.  'PREV' switch added.
*. 12-Mar-00   T.Mori          Written.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "xnctrl.inc"
#include "xngcom.inc"
#include "gksenum.inc"
#include "rcrep.inc"
*
      INTEGER CHDNR, ICASE, NOITEM
      PARAMETER (CHDNR = 1)
      INTEGER IDUMY, IRET, IMENU
      PARAMETER (NOITEM = 10)  ! number of items in the menu
      CHARACTER*6 CHITEM(NOITEM), CHPSON, CHPSOF, CHVIEW(2), CHLOG(2)
      CHARACTER*6 CHXYZ(2)
      CHARACTER*1 CDUMMY
      DATA CHITEM /
     + 'NEXT  ', 'PREV  ', 'KAM   ', 'ZOOM  ', 'UNZOOM', 
     + 'PS ON ', 'LOG   ', 'CLEAR ', 'X/Y/Z ', 'QUIT  '/
      DATA CHPSON /'PS ON '/
      DATA CHPSOF /'PS OFF'/
      DATA CHVIEW /'KAM   ', 'XYZ   '/
      DATA CHLOG  /'LOG   ', 'LIN   '/
      DATA CHXYZ  /'X/Y/Z ', 'EDEPO '/
*
      IF (ITYPE .NE.1 .AND. ITYPE .NE. 2) ITYPE = 1
*
*-- Clear screen and/or PS
*
      MSGON = 0
      CALL ICLRWK(KWIDGR, GALWAY)
      IF (METAON .EQ. 1) CALL ICLRWK(KWIDMF, GALWAY)
*
*-- Start drawing
*
   10 CONTINUE
*
*   - Fill black background for color PS file
      IF (METAON .EQ. 1 .AND. PSCOLO .EQ. 1) CALL XNPSBG
*
* === XYZ views
*
      IF ( ITYPE .EQ. 1 ) THEN
*
         IMENU = 1
         CALL XNHEAD
         CALL XNDXYZ
C         CALL XNPWGT    ! plot weighted mean position
         CALL XNDMC
*
* === unfolded Kamiokande-like plot
*
      ELSE IF ( ITYPE .EQ. 2 ) THEN
*
         IMENU = 2
         CALL XNHEAD
         IF (JKAMC .EQ. 0) THEN
            CALL XNDKAM
         ELSE
            CALL XNDPMT
            CALL XNDKMC
         END IF
         CALL XNDMC
*
      END IF
*
*-- Request MENU selection
*
  100 CONTINUE
      IF (ITYPE .EQ. 1 .OR. ITYPE .EQ. 2) THEN
         CHITEM(3) = CHVIEW(ITYPE)
         CHITEM(9) = CHXYZ(ITYPE)
      END IF
      IF (METAON .EQ. 1) THEN
         CHITEM(6) = CHPSOF
      ELSE
         CHITEM(6) = CHPSON
      END IF
      CHITEM(7) = CHLOG(JLOGP+1)
*
      CALL IGMENU(0, 'Click',
     +            X1MENU(IMENU), X2MENU(IMENU),
     +            Y1MENU(IMENU), Y2MENU(IMENU),
     +            0, CDUMMY, NOITEM, CHITEM, CDUMMY, CDUMMY,
     +            ICASE, 'CDRS')
*
      IF ( ICASE .LE. 0 ) GOTO 100
      IF ( ICASE .EQ. 1 ) THEN    ! goto next event
         IRET = IEVENT + 1
         CALL XNTRI(IRET)
         CALL ICLRWK(KWIDGR, GALWAY)
         IF (METAON .EQ. 1) CALL ICLRWK(KWIDMF, GALWAY)
         IF (IRET .EQ. 0) THEN
            GOTO 10
         ELSE 
            CALL ISELNT(JTNRHD)
            CALL ISPLCI(1)
            CALL ISTXCI(1)
            CALL ISTXAL(GALEFT, GAHALF)
            CALL ISCHUP(0., 1.)
            CALL ISCHH(60.)
            CALL ISTXFP(0, 2)
            IF (IRET .EQ. 1) THEN
               CALL ITX(0., 0., ' END OF FILE ')
               CALL ITX(0., 0., ' END OF FILE ')
               CALL ITX(0., 0., ' END OF FILE ')
               CALL ITX(0., 0., ' END OF FILE ')
            ELSE IF (IRET .EQ. 2) THEN
               CALL ITX(0., 0., ' BEG OF FILE ')
               CALL ITX(0., 0., ' BEG OF FILE ')
               CALL ITX(0., 0., ' BEG OF FILE ')
               CALL ITX(0., 0., ' BEG OF FILE ')
            ELSE
               CALL ITX(0., 0., ' ERROR ')
               CALL ITX(0., 0., ' ERROR ')
               CALL ITX(0., 0., ' ERROR ')
               CALL ITX(0., 0., ' ERROR ')
            END IF
         END IF
      ELSE IF ( ICASE .EQ. 2 ) THEN    ! goto previous event
         IRET = IEVENT - 1
         CALL XNTRI(IRET)
         CALL ICLRWK(KWIDGR, GALWAY)
         IF (METAON .EQ. 1) CALL ICLRWK(KWIDMF, GALWAY)
         IF (IRET .EQ. 0) THEN
            GOTO 10
         ELSE 
            CALL ISELNT(JTNRHD)
            CALL ISPLCI(1)
            CALL ISTXCI(1)
            CALL ISTXAL(GALEFT, GAHALF)
            CALL ISCHUP(0., 1.)
            CALL ISCHH(60.)
            CALL ISTXFP(0, 2)
            IF (IRET .EQ. 1) THEN
               CALL ITX(0., 0., ' END OF FILE ')
               CALL ITX(0., 0., ' END OF FILE ')
               CALL ITX(0., 0., ' END OF FILE ')
               CALL ITX(0., 0., ' END OF FILE ')
            ELSE IF (IRET .EQ. 2) THEN
               CALL ITX(0., 0., ' BEG OF FILE ')
               CALL ITX(0., 0., ' BEG OF FILE ')
               CALL ITX(0., 0., ' BEG OF FILE ')
               CALL ITX(0., 0., ' BEG OF FILE ')
            ELSE
               CALL ITX(0., 0., ' ERROR ')
               CALL ITX(0., 0., ' ERROR ')
               CALL ITX(0., 0., ' ERROR ')
               CALL ITX(0., 0., ' ERROR ')
            END IF
         END IF
      ELSE IF ( ICASE .EQ.  3 ) THEN    ! Kamiokande / Side views
         IF (ITYPE .EQ. 1) THEN
            ITYPE = 2
         ELSE IF (ITYPE .EQ. 2) THEN
            ITYPE = 1
         END IF
         CALL ICLRWK(KWIDGR, GALWAY)
         IF (METAON .EQ. 1) CALL ICLRWK(KWIDMF, GALWAY)
         GOTO 10
      ELSE IF ( ICASE .EQ.  4 ) THEN    ! zoom up
         CALL XNZOOM
         CALL ICLRWK(KWIDGR, GALWAY)
         IF (METAON .EQ. 1) CALL ICLRWK(KWIDMF, GALWAY)
         GOTO 10
      ELSE IF ( ICASE .EQ.  5 ) THEN    ! un-zoom
         CALL XNUNZO
         CALL ICLRWK(KWIDGR, GALWAY)
         IF (METAON .EQ. 1) CALL ICLRWK(KWIDMF, GALWAY)
         GOTO 10
      ELSE IF ( ICASE .EQ.  6 ) THEN    ! on/off a PS file
         IF (METAON .EQ. 1) THEN
            CALL XNPSOF
         ELSE
            CALL XNPSON
         END IF
         CALL ICLRWK(KWIDGR, GALWAY)
         GOTO 10
      ELSE IF ( ICASE .EQ. 7 ) THEN    ! toggle log scale plot
         IF (JLOGP .EQ. 0) THEN
           JLOGP = 1
         ELSE
           JLOGP = 0
         END IF
         CALL ICLRWK(KWIDGR, GALWAY)
         GOTO 10
      ELSE IF ( ICASE .EQ. 8 ) THEN    ! clear screen and draw
         CALL ICLRWK(KWIDGR, GALWAY)
         GOTO 10
      ELSE IF ( ICASE .EQ. 9 ) THEN    ! permute standard views
         IF (ITYPE .EQ. 1) THEN
            IDUMY = JTNR1
            JTNR1 = JTNR2
            JTNR2 = JTNR3
            JTNR3 = IDUMY
         ELSE
            IF (JKAMC .EQ. 0) THEN
               JKAMC = 1
            ELSE
               JKAMC = 0
            END IF
         END IF
         CALL ICLRWK(KWIDGR, GALWAY)
         IF (METAON .EQ. 1) CALL ICLRWK(KWIDMF, GALWAY)
         GOTO 10
      END IF
*
      MSGON = 1
*
      RETURN
      END
