      SUBROUTINE XNDXYZ
*.
*...XNDXYZ   Draw ...
*.
*. SEQUENCE  : NTUPLE RCREP  XNCGEO XNCINT XNCTRL XNGCOM
*. CALLS     : IPL    ISELNT ISLN   ISPLCI VZERO  XNDBIN
*. CALLED    : XNDRAW
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.00
*. CREATED   : 12-Mar-99
*. LAST MOD  : 18-May-00
*.
*. Modification Log.
*. 18-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's xedxyz.F.  XPMT -> PMTINT.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "xnctrl.inc"
#include "xngcom.inc"
#include "gksenum.inc"
#include "rcrep.inc"
*
      INTEGER I, J, K, IW
      REAL    PX(5), PY(5)
      REAL    XP(MXPMTS,NWALL), YP(MXPMTS,NWALL), ZP(MXPMTS,NWALL)
      REAL    X0, X1, X2, X, Y0, Y1, Y2, Y
*
*-- Calculate projected histograms
*
      CALL VZERO(XP, MXPMTS*NWALL)
      CALL VZERO(YP, MXPMTS*NWALL)
      CALL VZERO(ZP, MXPMTS*NWALL)
*
      DO IW = 1, 2           ! X wall
      DO I = 1, NIJPMT(1,IW) ! Y
      DO J = 1, NIJPMT(2,IW) ! Z
         K = I + (J-1)*IJOFFS(IW) + IWOFFS(IW)
         YP(I,IW) = YP(I,IW) + FLOAT(NPE(K))
         ZP(J,IW) = ZP(J,IW) + FLOAT(NPE(K))
      END DO
      END DO
      END DO
      DO IW = 3, 4           ! Y wall
      DO I = 1, NIJPMT(1,IW) ! Z
      DO J = 1, NIJPMT(2,IW) ! X
         K = I + (J-1)*IJOFFS(IW) + IWOFFS(IW)
         ZP(I,IW) = ZP(I,IW) + FLOAT(NPE(K))
         XP(J,IW) = XP(J,IW) + FLOAT(NPE(K))
      END DO
      END DO
      END DO
      DO IW = 5, 6           ! Z wall
      DO I = 1, NIJPMT(1,IW) ! X
      DO J = 1, NIJPMT(2,IW) ! Y
         K = I + (J-1)*IJOFFS(IW) + IWOFFS(IW)
         XP(I,IW) = XP(I,IW) + FLOAT(NPE(K))
         YP(J,IW) = YP(J,IW) + FLOAT(NPE(K))
      END DO
      END DO
      END DO
*
*-- Select first view (YZ)
*
      CALL ISELNT(JTNR1)
*
      X0 = WALL(3) + PMTINT/2.
      Y1 = WCATH(5)
      Y2 = WCATH(6)
      DO I = 1, NYPMT
         X = X0 + FLOAT(I-1)*PMTINT
         CALL XNDBIN(X, Y1, YP(I,5), 2)
         CALL XNDBIN(X, Y2, YP(I,6), 1)
      END DO
*
      Y0 = WALL(5) + PMTINT/2.
      X1 = WCATH(3)
      X2 = WCATH(4)
      DO I = 1, NZPMT
         Y = Y0 + FLOAT(I-1)*PMTINT
         CALL XNDBIN(X1, Y, ZP(I,3), 4)
         CALL XNDBIN(X2, Y, ZP(I,4), 3)
      END DO
*
*-- Draw walls
*
      PX(1) = WALL(3)  ! -y wall
      PY(1) = WALL(5)  ! -z wall
      PX(2) = WALL(4)
      PY(2) = WALL(5)
      PX(3) = WALL(4)
      PY(3) = WALL(6)
      PX(4) = WALL(3)
      PY(4) = WALL(6)
      PX(5) = PX(1)
      PY(5) = PY(1)
      CALL ISPLCI(1)
      CALL ISLN(GLSOLI)
      CALL IPL(5, PX, PY)
*
*-- Select second view (XZ)
*
      CALL ISELNT(JTNR2)
*
      X0 = WALL(1) + PMTINT/2.
      Y1 = WCATH(5)
      Y2 = WCATH(6)
      DO I = 1, NXPMT
         X = X0 + FLOAT(I-1)*PMTINT
         CALL XNDBIN(X, Y1, XP(I,5), 2)
         CALL XNDBIN(X, Y2, XP(I,6), 1)
      END DO
*
      Y0 = WALL(5) + PMTINT/2.
      X1 = WCATH(1)
      X2 = WCATH(2)
      DO I = 1, NZPMT
         Y = Y0 + FLOAT(I-1)*PMTINT
         CALL XNDBIN(X1, Y, ZP(I,1), 4)
         CALL XNDBIN(X2, Y, ZP(I,2), 3)
      END DO
*
*-- Draw walls
*
      PX(1) = WALL(1)  ! -x wall
      PY(1) = WALL(5)  ! -z wall
      PX(2) = WALL(2)
      PY(2) = WALL(5)
      PX(3) = WALL(2)
      PY(3) = WALL(6)
      PX(4) = WALL(1)
      PY(4) = WALL(6)
      PX(5) = PX(1)
      PY(5) = PY(1)
      CALL ISPLCI(1)
      CALL ISLN(GLSOLI)
      CALL IPL(5, PX, PY)
*
*-- Select third view (XY)
*
      CALL ISELNT(JTNR3)
*
      X0 = WALL(1) + PMTINT/2.
      Y1 = WCATH(3)
      Y2 = WCATH(4)
      DO I = 1, NXPMT
         X = X0 + FLOAT(I-1)*PMTINT
         CALL XNDBIN(X, Y1, XP(I,3), 2)
         CALL XNDBIN(X, Y2, XP(I,4), 1)
      END DO
*
      Y0 = WALL(3) + PMTINT/2.
      X1 = WCATH(1)
      X2 = WCATH(2)
      DO I = 1, NYPMT
         Y = Y0 + FLOAT(I-1)*PMTINT
         CALL XNDBIN(X1, Y, YP(I,1), 4)
         CALL XNDBIN(X2, Y, YP(I,2), 3)
      END DO
*
*-- Draw walls
*
      PX(1) = WALL(1)  ! -x wall
      PY(1) = WALL(3)  ! -y wall
      PX(2) = WALL(2)
      PY(2) = WALL(3)
      PX(3) = WALL(2)
      PY(3) = WALL(4)
      PX(4) = WALL(1)
      PY(4) = WALL(4)
      PX(5) = PX(1)
      PY(5) = PY(1)
      CALL ISPLCI(1)
      CALL ISLN(GLSOLI)
      CALL IPL(5, PX, PY)
*
      RETURN
      END
