      SUBROUTINE XNEWGT
*.
*...XNEWGT   Calculate and show weighted mean position of energy depo.
*.
*. SEQUENCE  : NTUPLE RCREP  XECGEO XECINT XNCTRL XNGCOM
*. CALLS     : IPL    ISELNT ISLN   ISPLCI VZERO
*. CALLED    : XNTRI
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.01
*. CREATED   : 15-Mar-99
*. LAST MOD  : 03-Jul-02
*.
*. Modification Log.
*. 03-Jul-02   K.Ozone         (V1.01) Change XDEPO to XDEPOS
*. 18-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's xeewgt.F.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "xnctrl.inc"
#include "xngcom.inc"
#include "gksenum.inc"
#include "rcrep.inc"
*
      REAL    WSCALE
      PARAMETER (WSCALE = 1.)  ! scale factor for sigma plot
      INTEGER I, J
      REAL    XTOT, XW2(3), PX(2), PY(2)
*
*-- Calculate weighted-mean position
*
      CALL VZERO(XW,  3)
      CALL VZERO(XW2, 3)
      XTOT = 0.
      DO 100 I = 1, NDEPO
      DO 100 J = 1, 3
         XTOT   = XTOT   + XDEPOS(4,I)
         XW(J)  = XW(J)  + XDEPOS(J,I)*XDEPOS(4,I)
         XW2(J) = XW2(J) + XDEPOS(J,I)*XDEPOS(J,I)*XDEPOS(4,I)
  100 CONTINUE
*
      DO 200 J = 1, 3
         XW(J)  = XW(J)/XTOT
         XW2(J) = XW2(J)/XTOT
         SW(J)  = XW2(J) - XW(J)*XW(J)
         IF (SW(J) .GE. 0.) THEN
            SW(J) =  SQRT(SW(J))
         ELSE
            SW(J) = -SQRT(-SW(J))
         END IF
  200 CONTINUE
*
C      RW = SQRT(XW(1)**2 + XW(2)**2)
*
*-- color and line type
*
      CALL ISPLCI(6)    ! magenta
      CALL ISLN(GLDOT)
*
*-- Select first view (YZ)
*
      CALL ISELNT(JTNR1)
      PX(1) = XW(2) - SW(2)*WSCALE
      PX(2) = XW(2) + SW(2)*WSCALE
      PY(1) = XW(3)
      PY(2) = XW(3)
      CALL IPL(2, PX, PY)
      PX(1) = XW(2)
      PX(2) = XW(2)
      PY(1) = XW(3) - SW(3)*WSCALE
      PY(2) = XW(3) + SW(3)*WSCALE
      CALL IPL(2, PX, PY)
*
*-- Select second view (XZ)
*
      CALL ISELNT(JTNR2)
      PX(1) = XW(1) - SW(1)*WSCALE
      PX(2) = XW(1) + SW(1)*WSCALE
      PY(1) = XW(3)
      PY(2) = XW(3)
      CALL IPL(2, PX, PY)
      PX(1) = XW(1)
      PX(2) = XW(1)
      PY(1) = XW(3) - SW(3)*WSCALE
      PY(2) = XW(3) + SW(3)*WSCALE
      CALL IPL(2, PX, PY)
*
*-- Select third view (XY)
*
      CALL ISELNT(JTNR3)
      PX(1) = XW(1) - SW(1)*WSCALE
      PX(2) = XW(1) + SW(1)*WSCALE
      PY(1) = XW(2)
      PY(2) = XW(2)
      CALL IPL(2, PX, PY)
      PX(1) = XW(1)
      PX(2) = XW(1)
      PY(1) = XW(2) - SW(2)*WSCALE
      PY(2) = XW(2) + SW(2)*WSCALE
      CALL IPL(2, PX, PY)
*
      RETURN
      END
