      SUBROUTINE XNFILE
*.
*...XNFILE   Open a new input file
*.
*. SEQUENCE  : NTUPLE RCREP  XNCGEO XNCINT XNCTRL XNGCOM
*. CALLS     : HBNAME HBSET  HNOENT HROPEN HRIN   KUGETS
*.           : GETPIDF SYSTEM
*.           : REPORT XNGWND
*. CALLED    : XNIKU
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.01
*. CREATED   : 12-Mar-99
*. LAST MOD  : 03-Jul-02
*.
*. Modification Log.
*. 03-Jul-02   K.Ozone         (V1.01) Change blockname of ntuple
*. 18-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's xefile.F.  NAEVT -> NEVENT.
*.                             /bin/mkfifo -> /usr/bin/mkfifo.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "xnctrl.inc"
#include "xngcom.inc"
#include "rcrep.inc"
*
      INTEGER LENGTH, ISTAT, MYPID
      CHARACTER*80 SYSCOM
      INTEGER  LENOCC
      EXTERNAL LENOCC
      INTEGER INIT
      SAVE    INIT
      DATA    INIT / 0 /
*
*-- Close the current file (if any)
*
      CALL KUGETS(INNAME, LENGTH)
      IF (INIT .NE. 0) THEN
         CLOSE(LUNDAT)
         IF (CPIPE .NE. ' ') THEN
            CALL SYSTEM('/bin/rm -f '//CPIPE(1:LENOCC(CPIPE)))
            CALL SYSTEM('/bin/rm -f nohup.out')
         END IF
      ELSE
         CALL HBSET('BSIZE', NRECNT, ISTAT)   ! set block size
         IF (ISTAT .NE. 0) GOTO 902
         INIT = 1
      END IF
*
*-- Open it directly or through pipe if gzipped
*
      CPIPE = ' '
      IF (INNAME(LENGTH-2:LENGTH) .NE. '.gz') THEN
C         IF (INNAME(LENGTH-4:LENGTH) .NE. '.hbk') THEN
C            INNAME = INNAME(1:LENGTH)//'.hbk'
C         END IF
         CALL HROPEN(LUNDAT, 'MYNT', INNAME, ' ', NRECNT, ISTAT)
         IF (ISTAT .NE. 0) GOTO 910
      ELSE
         CPIPE(1:20) = '/tmp/xnscan_pipe_pid'
         CALL GETPIDF(MYPID)
         WRITE(CPIPE(21:), '(I5.5)') MYPID
         WRITE(SYSCOM, '(''/usr/bin/mkfifo '', A, '' 2>/dev/null'')')
     +      CPIPE(1:LENOCC(CPIPE))
         CALL SYSTEM(SYSCOM)
         CALL SYSTEM('nohup /usr/local/bin/gunzip -c '//
     +      INNAME(1:LENGTH)//' > '//
     +      CPIPE(1:LENOCC(CPIPE))//' 2>nohup.out &')
         CALL HROPEN(LUNDAT, 'MYNT', CPIPE, ' ', NRECNT, ISTAT)
         IF (ISTAT .NE. 0) GOTO 910
      END IF
*
*-- Set up the ntuple
*
      CALL HRIN(IDNTPL, 999999, 0)                  ! read into memory
      CALL HBNAME(IDNTPL, ' ', 0, '$CLEAR')         ! clear & 
      CALL HBNAME(IDNTPL, BLKEVT, EVENT,  '$SET')    ! set addresses
      CALL HBNAME(IDNTPL, BLKBEM, EIN,    '$SET')    ! set addresses
      CALL HBNAME(IDNTPL, BLKITR, DEXE,   '$SET')    ! set addresses
      CALL HBNAME(IDNTPL, BLKLPM, NPE,    '$SET')    ! set addresses
      CALL HBNAME(IDNTPL, BLKSUM, NTOTPE, '$SET')    ! set addresses
      CALL HBNAME(IDNTPL, BLKDEP, NDEPO,  '$SET')    ! set addresses
      CALL HNOENT(IDNTPL, NEVENT)
      WRITE(CHREP, '(''Reading '', A)') INNAME
      CALL REPORT('XNFILE', 1, 'INFO')
      WRITE(CHREP, '(''Number of events to read:'', I8)') NEVENT
      CALL REPORT('XNFILE', 2, 'INFO')
*
      MDREAD = 0   ! # events read in this ntuple
*
      RETURN
*
C  900 CONTINUE
C      WRITE(CHREP, 601) INNAME,IRET
C  601 FORMAT('File ', A8, ' read error. IRET=',I5)
C      CALL REPORT('XNFILE', 11, 'ERROR')
C      GOTO 999
*
  902 CONTINUE
      WRITE(CHREP, '(''Error in HBSET:'', I4)') ISTAT
      CALL REPORT('XNFILE', 12, 'ERROR')
      GOTO 999
*
  910 CONTINUE
      WRITE(CHREP, 602) INNAME
  602 FORMAT('No such file: ', A)
      CALL REPORT('XNFILE', 13, 'ERROR')
*
  999 CONTINUE
      RETURN
      END
