      PROGRAM XNMAIN
*.
*...XNMAIN   Main program for event-scanning ntuples created by lproto
*.
*. SEQUENCE  : NTUPLE RCREP  XECGEO XECPMT XECINT XNCTRL XNGCOM
*. CALLS     : HLIMIT IGINIT IGWKTY INITC  KUEXEC KUINIT KUWHAG
*.           : PRIREP XEGINI XNGINI XNGFIN XNIKU
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.00
*. CREATED   : 10-Mar-99
*. LAST MOD  : 18-May-00
*.
*. Modification Log.
*. 18-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's main_xe.F.
*.
*.**********************************************************************
*.
#include "declare.inc"
*
      INTEGER NHMEM,  HMEMOR
      PARAMETER (NHMEM = 2000000)
      COMMON /PAWC/ HMEMOR(NHMEM)
*
#include "xecgeo.inc"
#include "xecpmt.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "xnctrl.inc"
#include "xngcom.inc"
#include "rcrep.inc"
*
      INTEGER IWKTYP
*
*-- Initialize HBOOK memory
*
      CALL HLIMIT(NHMEM)
*
*-- Initialize KUIP with 5000 words as minimum division size.
*
      CALL KUINIT(5000)
*
*-- Initialize HIGZ with 10000 words as minimum division size as in PAW
*   (T.Mori: Little or no improvement is observed in drawing speed
*    by this.)
*
      CALL IGINIT(10000)
*
*-- Initialize parameters in /XNCTRL/
*
      LUNREP =  6
      LUNHBK = 10
      LUNPS  = 11
      LUNDAT = 12
*
*-- Initialize geometrical parameters in /XECGEO/
*
      NXPMT  = 6
      NYPMT  = 6
      NZPMT  = 8
      PMTINT = 6.2
      CALL XEGINI
*
*-- Initialize parameter(s) in /XECPMT/
*
      RCATH  = 4.5/2.
*
*-- Ask the user for workstation type for the graphic display
*
      CALL IGWKTY(IWKTYP)
      CALL INITC()
*
*-- Initialize graphics
*
      CALL XNGINI(IWKTYP)
*
*-- Definition routine name for XNSCAN
*
      CALL XNIKU
*
*-- Change the command prompt
*
      CALL KUEXEC('SET/PROMPT ''XNS>''')
*
*-- Give control to KUIP
*
      CALL KUWHAG
*
*-- Command QUIT or EXIT bring us here
*
*-- Print REPORT summary
*
      CALL PRIREP
*
*-- Finish up
*
      CALL XNGFIN
*
  999 CONTINUE
      STOP
      END
*
      SUBROUTINE REPORT(CROUT, IDMESS, CSEVER)
*.
*...REPORT   Fake ROPE's REPORT facility
*.
*. SEQUENCE  : RCREP  XNCTRL
*. CALLS     : None
*. CALLED    : Many routines
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.00
*. CREATED   : 08-May-00
*. LAST MOD  : 08-May-00
*.
*. Modification Log.
*. 18-May-00   T.Mashimo       ucntrl.inc -> xnctrl.inc.
*. 08-May-00   T.Mashimo       (V1.00) First version for ANALNT.
*.                             gmflag.inc -> ucntrl.inc.
*. 13-Apr-00   T.Mashimo       Change report.inc to rcrep.inc.
*.                             Change LTHOUT to LUNREP and
*.                             add gmflag.inc.
*. 11-Mar-93   T.Mori          A modified copy created in MDLIB
*.                             (mdst scan).
*. 06-Apr-92   T.Mori          Prints a caution to suppress the messages
*. 08-Oct-90   T.Mori          Entry THXREP prints out a summary.
*. 27-Sep-90   T.Mori          Create for mDST analysis.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xnctrl.inc"
#include "rcrep.inc"
*
      INTEGER MAXSAV,MAXOUT
      PARAMETER (MAXSAV=500,MAXOUT=20)
      CHARACTER*(*) CSEVER
      CHARACTER*(*) CROUT
      CHARACTER*1   SESAVE(MAXSAV),SEVERE(6,2)
      CHARACTER*6   PNAME,PSAVE(MAXSAV)
      CHARACTER*80  COMME,COSAVE(MAXSAV)
      INTEGER IDMESS,IDSAVE(MAXSAV),ICSAVE(MAXSAV),I,J
      INTEGER NSAVE
      SAVE ICSAVE,PSAVE,IDSAVE,COSAVE,SESAVE
      SAVE NSAVE,SEVERE
      DATA NSAVE / 0/
      DATA SEVERE /'C','F','E','W','I','S',
     +             'c','f','e','w','i','s'/
*
      WRITE(COMME,'(A80)') CHREP
      WRITE(PNAME,'(A6)') CROUT
*
      DO 100 I=1,NSAVE
        IF(PNAME.EQ.PSAVE(I).AND.IDMESS.EQ.IDSAVE(I)) THEN
          ICSAVE(I)=ICSAVE(I)+1
          IF(ICSAVE(I).LE.MAXOUT) THEN
            GOTO 110
          ELSE
            RETURN
          END IF
        END IF
  100 CONTINUE
      NSAVE=NSAVE+1
      PSAVE(NSAVE)=PNAME
      IDSAVE(NSAVE)=IDMESS
      COSAVE(NSAVE)=COMME
      SESAVE(NSAVE)=CSEVER(1:1)
      ICSAVE(NSAVE)=1
  110 CONTINUE
*
      IF(ICSAVE(I).EQ.MAXOUT) WRITE(LUNREP,1010)
      WRITE(LUNREP,1000) PNAME,IDMESS,CSEVER(1:1),IEVENT,COMME
*
      RETURN
      ENTRY PRIREP
*
*...PRIREP   Prints out REPORT messages at end of job
*
      WRITE(LUNREP,5010)
      DO 510 J=1,6
      DO 520 I=1,NSAVE
        IF(SESAVE(I).EQ.SEVERE(J,1).OR.SESAVE(I).EQ.SEVERE(J,2)) THEN
          WRITE(LUNREP,5020) ICSAVE(I),PSAVE(I),SESAVE(I),COSAVE(I)
        END IF
  520 CONTINUE
  510 CONTINUE
      WRITE(LUNREP,5090)
*
      RETURN
*
 1000 FORMAT(' ',A,'-',I4,'- ',A,'  ',I6,'  ',A)
 1010 FORMAT(' REPORT-I- The following message will be suppressed : ')
 5010 FORMAT(' '/' ',27('-'),' Report Message Summary ',27('-')/' ')
 5020 FORMAT(' ',I6,' ',A,' ',A,' ',A)
 5090 FORMAT(' '/' ',27('-'),'------------------------',27('-')/' ')
      END
