      SUBROUTINE XNPWGT
*.
*...XNPWGT   Plot weighted mean position
*.
*. SEQUENCE  : NTUPLE RCREP  XECGEO XECINT XNCTRL XNGCOM
*. CALLS     : IPL    ISELNT ISLN   ISPLCI
*. CALLED    : XNDRAW
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.00
*. CREATED   : 15-Mar-99
*. LAST MOD  : 18-May-00
*.
*. Modification Log.
*. 18-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's xepwgt.F.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "xnctrl.inc"
#include "xngcom.inc"
#include "gksenum.inc"
#include "rcrep.inc"
*
      REAL WSCALE
      PARAMETER (WSCALE = 1.)  ! scale factor for sigma plot
      REAL PX(2), PY(2)
*
*-- color and line type
*
      CALL ISPLCI(6)    ! magenta
      CALL ISLN(GLDOT)
*
*-- Select first view (YZ)
*
      CALL ISELNT(JTNR1)
      PX(1) = XW(2) - SW(2)*WSCALE
      PX(2) = XW(2) + SW(2)*WSCALE
      PY(1) = XW(3)
      PY(2) = XW(3)
      CALL IPL(2, PX, PY)
      PX(1) = XW(2)
      PX(2) = XW(2)
      PY(1) = XW(3) - SW(3)*WSCALE
      PY(2) = XW(3) + SW(3)*WSCALE
      CALL IPL(2, PX, PY)
*
*-- Select second view (XZ)
*
      CALL ISELNT(JTNR2)
      PX(1) = XW(1) - SW(1)*WSCALE
      PX(2) = XW(1) + SW(1)*WSCALE
      PY(1) = XW(3)
      PY(2) = XW(3)
      CALL IPL(2, PX, PY)
      PX(1) = XW(1)
      PX(2) = XW(1)
      PY(1) = XW(3) - SW(3)*WSCALE
      PY(2) = XW(3) + SW(3)*WSCALE
      CALL IPL(2, PX, PY)
*
*-- Select third view (XY)
*
      CALL ISELNT(JTNR3)
      PX(1) = XW(1) - SW(1)*WSCALE
      PX(2) = XW(1) + SW(1)*WSCALE
      PY(1) = XW(2)
      PY(2) = XW(2)
      CALL IPL(2, PX, PY)
      PX(1) = XW(1)
      PX(2) = XW(1)
      PY(1) = XW(2) - SW(2)*WSCALE
      PY(2) = XW(2) + SW(2)*WSCALE
      CALL IPL(2, PX, PY)
*
      RETURN
      END
