      SUBROUTINE XNTRI(IRET)
*.
*...XNTRI    Read a new event
*.
*. INPUT     : IRET = sequential event number in this ntuple file
*. OUTPUT    : IRET = 0  success
*.                  = 1  EOF
*.                  = 2  BOF
*.                  < 0  error
*.
*. SEQUENCE  : NTUPLE RCREP  XECGEO XECINT XNCTRL XNGCOM
*. CALLS     : HGNT   HGNTF
*.           : REPORT XNEWGT
*. CALLED    : XNDRAW XNGOTO XNIKU  XNNEXT XNSKIP XNTRIG
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.00
*. CREATED   : 12-Mar-99
*. LAST MOD  : 18-May-00
*.
*. Modification Log.
*. 18-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's xntri.F.
*.                             NAEVT -> NEVENT, NEVT -> IEVENT.
*. 19-Jun-99   T.Mori          Return IRET=1,2 for EOF,BOF.
*. 12-Mar-99   T.Mori          Written.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "xnctrl.inc"
#include "xngcom.inc"
#include "rcrep.inc"
*
      INTEGER IRET
*
      INTEGER ISTAT
*
      IEVENT = MAX( MIN(IRET, NEVENT), 1 )  ! event# to retrieve
*
*-- Read an event (an ntuple row)
*
      IF (MDREAD .EQ. 0) THEN    ! very first call
         CALL HGNT(IDNTPL, IEVENT, ISTAT)
      ELSE
         CALL HGNTF(IDNTPL, IEVENT, ISTAT)   ! fast routine
      END IF
      IF (ISTAT .NE. 0) GOTO 800       ! error
      MDREAD = MDREAD + 1           ! # events read in this file
*
      IF (IRET .GT. NEVENT) THEN  ! end of file
         IF ( MSGON .EQ. 1 ) THEN
            WRITE(CHREP, '(''End of file'', I10)') IEVENT
            CALL REPORT('XNTRI', 1, 'INFO')
         END IF
         IRET = 1  ! end of file
      ELSE IF (IRET .LE. 0) THEN
         IF ( MSGON .EQ. 1 ) THEN
            WRITE(CHREP,'(''Beginning of file'')') 
            CALL REPORT('XNTRI', 2, 'INFO')
         END IF
         IRET = 2  ! beginning of file
      ELSE
         IRET = 0  ! success
      END IF
*
*-- Calculate some event variables
*
C         CALL XNWGHT    ! weighted mean position by PMT
         CALL XNEWGT    ! weighted mean by energy deposits
*
C        IF (MSGON .EQ. 1) THEN
C           WRITE(CHREP, '(''Get event ='', I10)') IEVENT
C           CALL REPORT('XNTRI', 2, 'INFO')
C        END IF
*
      RETURN
*
*-- Error
*
  800 CONTINUE
      IF ( MSGON .EQ. 1 ) THEN
         WRITE(CHREP, '(''Error in reading an event'')')
         CALL REPORT('XETRI', 3, 'ERROR')
      END IF
      IRET = -1
*
  999 CONTINUE
      RETURN
      END
