      SUBROUTINE XNWGHT
*.
*...XNWGHT   Calculate weighted mean position by # of p.e. of each PMT
*.
*. SEQUENCE  : NTUPLE XNCGEO XNCINT XNCTRL XNGCOM
*. CALLS     : VZERO
*. CALLED    : XNTRI
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.00
*. CREATED   : 15-Mar-99
*. LAST MOD  : 18-May-00
*.
*. Modification Log.
*. 18-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's xewght.F.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "xnctrl.inc"
#include "xngcom.inc"
*
      INTEGER I, J
      REAL    XW2(3)
*
*-- Calculate weighted-mean position
*
      CALL VZERO(XW,  3)
      CALL VZERO(XW2, 3)
      DO 100 I = 1, NALPMT
      DO 100 J = 1, 3
         XW(J)  = XW(J)  + PMTPOS(J,I)*FLOAT(NPE(I))
         XW2(J) = XW2(J) + PMTPOS(J,I)*PMTPOS(J,I)*FLOAT(NPE(I))
  100 CONTINUE
*
      DO 200 J = 1, 3
         XW(J)  = XW(J) /FLOAT(NSUM)
         XW2(J) = XW2(J)/FLOAT(NSUM)
         SW(J)  = XW2(J) - XW(J)*XW(J)
         IF (SW(J) .GE. 0.) THEN
            SW(J) =  SQRT(SW(J))
         ELSE
            SW(J) = -SQRT(-SW(J))
         END IF
  200  CONTINUE
*
C      RW = SQRT(XW(1)**2 + XW(2)**2)
*
      RETURN
      END
