      SUBROUTINE XNWNVP(NT)
*.
*...XNWNVP   (Re)set window & viewport for Normalization Transf. NT
*.
*. SEQUENCE  : XNGCOM
*. CALLS     : ISWN   ISVP
*. CALLED    : XNGWND XNUNZO
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mori
*. VERSION   : 1.00
*. CREATED   : 12-Mar-99
*. LAST MOD  : 18-May-00
*.
*. Modification Log.
*. 18-May-00   T.Mashimo       (V1.00) First version based on
*.                             T. Mori's xewnvp.F.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "xngcom.inc"
*
      INTEGER NT
*
      REAL    WSMAL, WMRGN
*
*-- Event header
*
      IF (NT .EQ. JTNRHD) THEN
*
         CALL ISWN(JTNRHD, -900., 900., -900., 900.)
         CALL ISVP(JTNRHD, 0., RY/RX, 0., RY/RX)
*
*-- Standard view #1 (normally xy view)
*
      ELSE IF (NT .EQ. JSTD1) THEN
*
         CALL ISWN(JSTD1, XLO1, XHI1, YLO1, YHI1)
         XMEPOS = XLO1 + (XHI1-XLO1)/8.             ! for scale bar
         YMEPOS = YLO1 + (YHI1-YLO1)/8.             !
         WMEPOS = 10.**(NINT(ALOG10((XHI1-XLO1)/8.)))
         CALL ISVP(JSTD1, 0., RY/RX, 0., RY/RX) ! map to a square area
*
*-- Standard view #2 (normally zx view)
*
      ELSE IF (NT .EQ. JSTD2) THEN
*
         CALL ISWN(JSTD2, XLO2, XHI2, YLO2, YHI2)
         WSMAL = (1. - RY/RX) * 1.2
         WMRGN = (1. - RY/RX) * 0.1
         CALL ISVP(JSTD2, 1.-WSMAL, 1.,
     +             RY/RX-WSMAL-WMRGN, RY/RX-WMRGN) !right upper
*
*-- Standard view #3 (normally zy view)
*
      ELSE IF (NT .EQ. JSTD3) THEN
*
         CALL ISWN(JSTD3,XLO3,XHI3,YLO3,YHI3)
         WSMAL = (1. - RY/RX) * 1.2
         WMRGN = (1. - RY/RX) * 0.1
         CALL ISVP(JSTD3, 1.-WSMAL, 1.,
     +             0.+WMRGN, WSMAL+WMRGN) !right lower corner
*
*-- Standard view #4 (Kamiokande-like unfolded plot)
*
      ELSE IF (NT .EQ. JSTD4) THEN
*
         YHI4 = (XHI4-XLO4)*RY/RX/2.
         YLO4 = -YHI4
         CALL ISWN(JSTD4, XLO4, XHI4, YLO4, YHI4)
         CALL ISVP(JSTD4, 0., 1., 0., RY/RX)     ! map to whole screen
C         CALL ISVP(JSTD4, 0., RY/RX, 0., RY/RX) ! map to largest square
*
*-- Dummy view
*
      ELSE IF (NT .EQ. JDUMMY) THEN
*
*        Outside detector...
         CALL ISWN(JDUMMY, 1300., 2000., 1300., 2000.)
         WSMAL = (1. - RY/RX) * 1.2
         WMRGN = (1. - RY/RX) * 0.1
         CALL ISVP(JDUMMY, 1.-WSMAL, 1., 0.+WMRGN, WSMAL+WMRGN)
*
      END IF
*
      RETURN
      END
